class A extends Thread {

	int id;
	static Busy O;
	A(int n) {
		id = n;
	}
	
	public static void setSystem() {
		Busy tmp;
		tmp = new Busy();
		O = tmp;
	}
	
	public void run() {
		int tmp;
		tmp = id;
		if (tmp == 1) 				sayHello();
		else	if (tmp == 2)  	sayBye();
	}

	public void sayBye() {
		Busy tmp;
		tmp = O;
		tmp.getCond();
		System.out.println("Bye");
	}

	public void sayHello() {
		Busy tmp;
		tmp = O;
		System.out.println("Hello ");	
		tmp.signalCond();
		
	}
	
	public synchronized void test() {
		Busy tmp;
		System.out.println("Testing lock-Object freed");
		tmp = O;
		tmp.moreTest();
	}
	
	public static void main(String[] args) {
		int tmp;
		A myT1;
		A myT2;
		A myT3;
		A myT4;
		A myT5;
		A myT6;
		A myT7;
		A myT8;

		A.setSystem();	

		tmp = 1;
		myT1 = new A(tmp);		
		myT2 = new A(tmp);		
		myT3 = new A(tmp);
		myT4 = new A(tmp);		
		tmp = 2;
		myT5 = new A(tmp);
		myT6 = new A(tmp);		
		myT7 = new A(tmp);
		myT8 = new A(tmp);		

		
		myT5.start();		
		myT6.start();
		myT7.start();
		myT8.start();
		try {
			sleep(100);
		} catch (InterruptedException e) {
			System.out.println("Catch Main");
		}	
		//myT1.start();
		//myT2.start();
		//myT3.start();
		//myT4.start();	
		myT5.interrupt();		
		myT6.interrupt();
		myT7.interrupt();
		myT8.interrupt();
	}	
}

class Busy {

	public synchronized void getCond() {
		try {
			wait(250);
		} catch (InterruptedException e) {
			System.out.println("Busy Catch Block!");
		}
	}
	public synchronized void signalCond() {
		notify();
	}

	public synchronized void moreTest() {
		System.out.println("Testing more deeply...");
	}
}
class TestBlock extends Thread {

	public Object getObj() {
		Object o;
		o = new Object();
		return o;
	}

	public synchronized void Test() {
		synchronized (getObj()) {
			System.out.println("Synch");
			System.out.println("Synch");
			try {
				wait();
			} catch (InterruptedException e) {
				System.out.println("Test Catch!");
			}
		}
	}
	
	public void run() {
		Test();
	}

	public synchronized void freeTest() {
		synchronized (getObj()) {
			System.out.println("Freed");
		}
	}

	public static void main(String[] args) {
		TestBlock t;
		t = new TestBlock();
		t.start();
		try {
			sleep(100);
		} catch (InterruptedException e) {
			System.out.println("Catch Main");
		}
		t.interrupt();
		try {
			Thread.sleep(100);
		} catch (InterruptedException e) {
			System.out.println("Catch Main");
		}		
		t.freeTest();
		try {
			Thread.sleep(100);
		} catch (InterruptedException e) {
			System.out.println("Catch Main");
		}					
	}
}
