import se.lth.cs.robot.irb6.*;
import java.lang.*;

class Synchronize { // extends Thread {

    private Motors m;
    private int j;
    private boolean ini_sync_pos;
    private float ref;
  
  public Synchronize(int motor, Motors motors){

	j=motor;
	m=motors;
	ini_sync_pos=m.checkSync(j);
  }

    public float getReference(){
	return ref;
    }

  
    public boolean synchronize() {
	// Init
	boolean sync;
	boolean sync_pos;
	float v;

	//	ini_sync_pos=m.checkSync(j);

	// for each sample
	sync_pos=m.checkSync(j);
	if (ini_sync_pos){
	    v = -syncSpeed(j);
	    //	    if(j==1 || j==4){
	    //v=(float)-0.5;
	    //}else{
	    //v=(float)0.5;
	    //}	
	}else{
	    v = syncSpeed(j);
	    //	    if(j==1 || j==4){
	    //v=(float)0.5;
	    //}else{
	    //v=(float)-0.5;
	    //}
	}
	//	m.analogOut(j, v);

	if(sync_pos==ini_sync_pos) {
	    // still not synced
	    sync = false;
	    ref = v;
	} else{
	    // synced
	    sync = true;
	    ref = 0.0;
	}
	return sync;
    }
    //	sync_pos=ini_sync_pos;
    //	while(sync_pos==ini_sync_pos){
    //    try{
    //	sleep(350);
    //}catch(Exception e){
    //	System.out.println("Exception catched during sleep in Synchronize");}
    //sync_pos=m.checkSync(j);
    //}

	// when synchronized
    //	v=(float)0.0;
    //	m.analogOut(j,v);
    //	m.reset(j);
    //	    try {
    //		sleep(100);
    //	    } catch(Exception e) {
    //		System.out.println("Exception catched during sleep in Synchronize ");
    //	    }
    //	    m.setSafeBit();
	    //  System.out.println("Joint "+j" synchronized");

    //}

    public float syncSpeed(int j){
	float speed=(float)0.5;
	switch (j){
	case 1:return speed;
	case 2:return -speed;
	case 3:return -speed;
	case 4:return speed;
	case 5:return -speed; 
	   
	}
    }
}
