import se.lth.cs.robot.irb6.*;
import java.lang.*;

class Synchronize3 extends Thread {

    private Motors motors;

    public Synchronize3(){
	motors=new Motors();
    }

    public synchronized void run(){

	float v1, v2, v3;
	boolean ini_sync_pos1, ini_sync_pos2, ini_sync_pos3, sync_pos1,  sync_pos2,  sync_pos3;

	boolean	sync1, sync2, sync3;

	ini_sync_pos1=motors.checkSync(1);
	ini_sync_pos2=motors.checkSync(2);
	ini_sync_pos3=motors.checkSync(3);

	if(ini_sync_pos1){
	    v1=(float)-0.5;
	}
	else{
	    v1=(float)0.5;}
	if(ini_sync_pos2){
	    v2=(float)0.5;
	}
	else{
	    v2=(float)-0.5;}
	if(ini_sync_pos3){
	    v3=(float)0.5;
	}
	else{
	    v3=(float)-0.5;}

	motors.analogOut(1, v1);
	motors.analogOut(2, v2);
	motors.analogOut(3, v3);

	sync_pos1=ini_sync_pos1;
	sync_pos2=ini_sync_pos2;
	sync_pos3=ini_sync_pos3;

	sync1=false;
	sync2=false;
	sync3=false;

	while(!(sync1&&sync2&&sync3)){
	    if(sync_pos1==ini_sync_pos1){
	    }else {
		v1=(float)0.000;
		sync1=true;
	    }

	    if(sync_pos2==ini_sync_pos2){
	    }else {
		v2=(float)0.000;
		sync2=true;
	    }

	    if(sync_pos3==ini_sync_pos3){
	    }else {
		v3=(float)0.000;
		sync3=true;
	    }

	motors.analogOut(1, v1);
	motors.analogOut(2, v2);
	motors.analogOut(3, v3);
	try{
	    sleep(350);
	}catch(Exception e){
	    System.out.println("Exception catched during sleep in Synchronize3");}

	sync_pos1=motors.checkSync(1);
	sync_pos2=motors.checkSync(2);
	sync_pos3=motors.checkSync(3);
	}

motors.setSafeBit();
System.out.println("finished");

    }
}
