package regtest;


public class PrimTypesTest extends TestCase {

	private static int errCount = 0;

	public static int testAll() {
		System.out.println("  PrimTypesTest start");
		testChar();
		testParseInt();
		System.out.println("  PrimTypesTest finished");
		return errCount;
	}

	private static void testChar() {
		int err = 0;
		char i = '#';
		if (i != '#') {
			System.out.println("    testChar failed.");
			err++;
		}
		errCount += err;
	}

	private static void testParseInt() {
		int err = 0;
		String s = "112358";
		int i = Integer.parseInt(s);
		errCount += check(i == 112358,"    testParseInt failed.\n"+
				"      i = "+i+" (112358)");
	}


}
