package regtest;

import java.io.*;

public class ReflectionTest extends TestCase{

    private static int errCount = 0;

    public static int testAll() {
	System.out.println("  ReflectionTest start");
 	testForName();
	System.out.println("  ReflectionTest finished");
	return errCount;
    }

    private static void testForName() {
	try {
	    Class type = Class.forName("java.lang.Object");
// 	System.out.println(type.getName());
	    type = Class.forName("java.lang.Object");
	    errCount += check(type.getName().equals("java.lang.Object"),"    testForName failed.\n"+
			      "      type.getName()=="+type.getName()+" (java.lang.Object)");
	} catch (ClassNotFoundException e) {
	    System.out.println("    testForName failed, threw ClassNotFoundException.");
	}
    }


}
