public class RtaiPrio {
    public static void main(String[] args){
	System.out.println("RtaiPrio - main-start");
	Thread pt0 = new Thread0();
	Thread pt1 = new Thread1();
	Thread pt2 = new Thread2();
	System.out.println("RtaiPrio - created threads");

	pt0.setPriority(1);
	System.out.println("Thread 0: Priority = 1");
	System.out.println(pt0.getPriority());
	pt1.setPriority(5);
	System.out.println("Thread 1: Priority = 5");
	System.out.println(pt1.getPriority());
	pt2.setPriority(10);
	System.out.println("Thread 2: Priority = 10");
	System.out.println(pt2.getPriority());


	System.out.println("RtaiPrio - starting threads");
	pt2.start();
	pt1.start();
	pt0.start();
	System.out.println("RtaiPrio - started threads");
    }
}

class Thread0 extends Thread {
    private String str;
    private int counter = 0;

    public Thread0(){
	str = "Thread0 ";
    }

    public void run(){
	long banan;
	System.out.print(str);
	System.out.println(this.getPriority());
	for(int i = 0;i<100000;i++){
	    banan = i*i/13.13;
	    if((i%1000 == 0) && banan > 0) {
    		System.out.print("0");
	    }
	}
	System.out.println(" Thread 0 Finished");
    }
}

class Thread1 extends Thread {
    private String str;

    public Thread1(){
	str="Thread1 ";
    }

    public void run(){
	long banan;
	System.out.print(str);
	System.out.println(this.getPriority());
	for(int i = 0;i<100000;i++){
	    banan = i*i/13.13;
	    if((i%1000 == 0) && banan > 0){
    		System.out.print("1");
	    }
	}
	System.out.println(" Thread 1 Finished");
    }
}

class Thread2 extends Thread {
    private String str;

    public Thread2(){
	str="Thread2 ";
    }

    public void run(){
	long banan;

	System.out.print(str);
	System.out.println(this.getPriority());

	for(int i = 0;i<100000;i++){
	    banan = i*i/13.13;
	    if((i%1000 == 0) && banan > 0)
    		System.out.print("2");
	}
	System.out.println(" Thread 2 Finished");
    }
}


