#include <gc.h>
#include <javatypes.h>
#include <stdint.h>
#include "ClockDevice.h"

GC_VAR_FUNC_BEGIN(JBoolean, done_ClockInput_getAlarmFlag)
  GC_FUNC_ENTER
  {
    uint8_t data = GetAlarmFlag(); 
    GC_RETURN_VAR((JBoolean)data);
  }
  GC_FUNC_LEAVE
GC_VAR_FUNC_END(JBoolean, done_ClockInput_getAlarmFlag)

GC_VAR_FUNC_BEGIN(JInt, done_ClockInput_getChoice)
  GC_FUNC_ENTER
  {
    uint8_t data = GetInputMode();
    GC_RETURN_VAR((JInt)data);
  }
  GC_FUNC_LEAVE
GC_VAR_FUNC_END(JInt, done_ClockInput_getChoice)

GC_VAR_FUNC_BEGIN(JInt, done_ClockInput_getValue)
  GC_FUNC_ENTER
  {
    int32_t data = GetInputValue();
    GC_RETURN_VAR((JInt)data);
  }
  GC_FUNC_LEAVE
GC_VAR_FUNC_END(JInt, done_ClockInput_getValue)

