#include <avr/io.h>
#include <compat/ina90.h>
#include <gc.h>
#include <javatypes.h>
#include <stdint.h>
#include "ClockDevice.h"
#include <AVR_LCD.h>

GC_PROC_BEGIN(done_ClockOutput_setupAlarm)
  GC_FUNC_ENTER
{
  output(DDRE, 0x04); 
  output(PORTE, 0xef); 
}
  GC_FUNC_LEAVE
GC_PROC_END(done_ClockOutput_setupAlarm)

GC_PROC_BEGIN(done_ClockOutput_doAlarm)
  GC_FUNC_ENTER
{
  int j;
  output(PORTE, input(PORTE) & ~0x04);
  SetAlarmPulse(1);
  PrintClockLCD();
  for(j = 0; j < 130; j++) {
    int k;
    for(k = 0; k < 685; k++) {
      _NOP();
    }
  }
  output(PORTE, input(PORTE) | 0x04);
  SetAlarmPulse(0);
  PrintClockLCD();
}
  GC_FUNC_LEAVE
GC_PROC_END(done_ClockOutput_doAlarm)

GC_PROC_BEGIN(done_ClockOutput_showTime_int, JInt time)
  GC_FUNC_ENTER;
{
  SetClockTime(time);
  PrintClockLCD();
}
  GC_FUNC_LEAVE
GC_PROC_END(done_ClockOutput_showTime_int)

