/*
 * $Revision: 1.8.2.5 $
 * $Author: andersn $
 * $Date: 2005/04/20 14:02:12 $
 */
import se.lth.cs.realtime.*;

public class RTSystemTest extends Thread{
	
	public void run() {	
		
		int timeBufferSize = RTSystem.getTimeBufferSize(this);
		long t = RTSystem.currentTimeMicros();
		
		System.out.println("Running.........");
		
		for (int i = 0; i < 10; i++) {
			
			t += 1000000;

			System.out.println(i + ") Thread info (timeBufferSize=" + timeBufferSize + ")");
			for (int j = 0; j < timeBufferSize; j++) {
				System.out.println("\tRuntime: " + RTSystem.getRuntime(this, j) + 
						"\tEndtime: " + RTSystem.getEndtime(this, j));
			}
			
			try {
				RTSystem.sleepUntil(t);
			} catch (InterruptedException e) {
				System.out.println("Thread was interrupted");
			}
		}
	}

	public static void main(String[] args) {
		
		new RTSystemTest().start();
	}
}
