/* $Id: FrequencyError.java,v 1.3 2005/08/15 13:24:44 d02en Exp $       
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime;

/**
 * Error to be thrown when an actual frequency is outside the permitted frequency range,
 * such as a <code>SporadicThread</code> that is triggered too often.
 * 
 *  @see License
 */

public class FrequencyError extends RTError {
}
