/* $Id: InhibitEvent.java,v 1.4 2005/08/19 09:37:16 d02en Exp $         
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime.event;

import se.lth.cs.realtime.Activity;
import se.lth.cs.realtime.Timebase;

/**
 * Event requesting an activity to suspend or terminate itself.
 * 
 * @see License
 */

public class InhibitEvent extends ActivityEvent {

  /**
   * 
   */
  public InhibitEvent() {
    super();
  }

  /**
   * @param source
   */
  public InhibitEvent(Activity source) {
    super(source);
  }

  /**
   * @param ts
   */
  public InhibitEvent(long ts) {
    super(ts);
  }

  /**
   * @param source
   * @param ts
   */
  public InhibitEvent(Activity source, long ts) {
    super(source, ts);
  }

  /**
   * @param source
   * @param ts
   * @param timebase
   */
  public InhibitEvent(Activity source, long ts, Timebase timebase) {
    super(source, ts, timebase);
  }
}
