#ifndef __AUX_H__
#define __AUX_H__


#include <javatypes.h> //FIXME: This should be included in java_lang_Object.h
#include <java_lang_Object.h>
#include <gc.h>



void ljrt_monitor_init(void **__eFlag__, GC_PARAM(java_lang_Object,this));
/*FIXME: see C-code
void ljrt_monitor_free(GC_PARAM(java_lang_Object,this));
*/
void ljrt_monitor_free(java_lang_Object *this);
void ljrt_monitor_enter(void **__eFlag__, GC_PARAM(java_lang_Object,this));
void ljrt_monitor_leave(void **__eFlag__, GC_PARAM(java_lang_Object,this));

#define MONITOR_INIT(obj) \
  GC_PROC_CALL(ljrt_monitor_init, GC_PASS(obj))

#define MONITOR_FREE(obj) \
  GC_PROC_CALL(ljrt_monitor_free, GC_PASS(obj))

#define MONITOR_ENTER(obj) \
  GC_ASSIGN(__gc_monitor_obj, obj);\
  GC_PROC_CALL(ljrt_monitor_enter, GC_PASS(obj))

#define MONITOR_LEAVE(obj) \
  GC_PROC_CALL(ljrt_monitor_leave, GC_PASS(obj))

#endif
