/**
 * Copyright (C) 2003-2007  Anders Nilsson <anders.nilsson@cs.lth.se>
 * 
 * This file is part of ljrt.
 *
 **/

package java.lang;

// Phony definitions, andersn
public class PhonyWriter extends java.io.PrintStream {

    /**
     * Phony constructor just to make PhonyWriter happy in the case
     * where no dead code elimination is enabled.
     */
    public PhonyWriter() {
	super(null);
    }


	public native void print();
	public native void println();

	public native void print(int i);
	public native void println(int i);

	public native void print(char i);
	public native void println(char i);

	public native void print(short i);
	public native void println(short i);

	public native void print(long i);
	public native void println(long i);

	public native void print(boolean i);
	public native void println(boolean i);

	public native void print(float i);
	public native void println(float i);

	public native void print(double i);
	public native void println(double i);

	public native void print(String s);
	public native void println(String s);

	public void print(Object obj) {
		print(obj == null ? "null" : obj.toString());
	}
	public void println(Object obj) {
		println(obj == null ? "null" : obj.toString());
	}

	public void flush() {}
}
