package se.lth.control.io;

import java.io.File;
import java.io.IOException;
import java.net.Socket;
import java.net.SocketException;

public class UnixSocket extends Socket {

	public UnixSocket(String path) throws IOException {
		super(new UnixSocketImpl());
		connect(new UnixSocketAddress(path));
	}
	
	public UnixSocket(File path) throws IOException {
		super(new UnixSocketImpl());
		connect(new UnixSocketAddress(path));
	}

	public UnixSocket(UnixSocketImpl impl) throws IOException {
		super(impl);
		connect(new UnixSocketAddress());
	}
	

}
