package se.lth.control.io;

import java.io.File;
import java.net.InetSocketAddress;

public class UnixSocketAddress extends InetSocketAddress {

	private static final long serialVersionUID = 1L;
	private File path;
	
	public UnixSocketAddress(File path) {
		super(0);
		this.path = path;
	}

	public UnixSocketAddress(String path) {
		super(0);
		this.path = new File(path);
	}
	
	public UnixSocketAddress() {
		super(0);
	}

	public String getAbsolutePath() {
		if (path == null) {
			return null;
		} else {
			return path.getAbsolutePath();
		}
	}

	

}
