package se.lth.control.io;

import java.io.IOException;
import java.io.InputStream;

public class UnixSocketInputStream extends InputStream {

	private UnixSocketImpl socket;

	public UnixSocketInputStream(UnixSocketImpl socket) {
		this.socket = socket;
	}

	public int read() throws IOException {
		return socket.read();
	}
	
	public int read(byte[] data, int offset, int length) throws IOException {
		return socket.read(data, offset, length);
	}

}
