/*
 * Axis.java
 *
 * Created: 2000-08-23
 * Edited:  2000-08-23
 *
 */
package se.lth.control.plot;
/**
 * Description of <code>Axis</code>
 *
 *
 * @author Leif Andersson
 * @version 0.0
 */
public interface Axis  {
  public double getMin();   
   
  public double getMax(); 

  public int getGridSize();

  public double getGridPoint(int i);

  public int getAxisSize();

  public AxisPoint getAxisPoint(int i);

  public String getLabel();

  public String toString();
  
} // Axis
