package se.lth.control.realtime;

import se.lth.control.realtime.comedi.Comedi;

public class AnalogIn extends IOChannel {

  public AnalogIn(final int index) throws IOChannelException {
    super(index);
  }

  protected void open() throws IOChannelException {
    Comedi.analogInOpen(index);
  }

  protected void close() throws IOChannelException {
    Comedi.analogInClose(index);
  }

  public double get() throws IOChannelException {
    return Comedi.analogIn(index);
  }

}
