package se.lth.control.realtime;


import se.lth.control.realtime.comedi.Comedi;


public class AnalogOut extends IOChannel {

  public AnalogOut(int index) throws IOChannelException {
    super(index);
  }

  public void open() throws IOChannelException {
    Comedi.analogOutOpen(index);
  }

  public void close() throws IOChannelException {
    Comedi.analogOutClose(index);
  }

  public void set(double value) throws IOChannelException {
    Comedi.analogOut(index, value);
  }

}
