package se.lth.control.realtime;

import java.util.BitSet;

import se.lth.control.realtime.comedi.Comedi;

public class DigitalIn extends IOChannel {

  public DigitalIn(int index) throws IOChannelException {
    super(index);
  }

  public void open() throws IOChannelException {
    Comedi.digitalInOpen(index);
  }

  public void close() throws IOChannelException {
    Comedi.digitalInClose(index);
  }

  public boolean get() throws IOChannelException {
    return Comedi.digitalIn(index);
  }

}
