package se.lth.control.realtime;

public abstract class IOChannel {

  public final int index;

  public IOChannel(int index) throws IOChannelException {
    this.index = index;
    open();
  }

  protected abstract void open() throws IOChannelException;
  protected abstract void close() throws IOChannelException;

}
