/* $Id: Activity.java,v 1.2 2005/08/22 08:18:22 d02en Exp $ 
 * 
 * Part of LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime;

/**
 * General functionality of concurrent activities; light-weight (threads) or
 * heavy-weight (OS) processes.
 * 
 * @see License
 */

public interface Activity {

  Timebase getTimebase();

  Environment getEnv();

  //boolean isStarted();

  boolean isAlive();

  //boolean isInterrupted();
  
  //void interrupt();
  
  void start();

  void join() throws InterruptedException;

  void terminate();

}
