/* $Id: RTDelayed.java,v 1.4 2005/08/15 13:24:44 d02en Exp $        
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime;

/**
 * @see License
 */

public class RTDelayed extends RTError {

  public volatile long until;

  public volatile int delay;

  public RTDelayed(long until, int delay) {
    super();
    this.until = until;
    this.delay = delay;
  }

  public long getDesiredMillis() {
    return until;
  }

  public int getDelayMillis() {
    return delay;
  }
}
