package se.lth.cs.robot.servo;

import se.lth.cs.realtime.event.RTEventListener;

public interface SDSoutput extends RTEventListener{

    /** Return a sample of the output signal
     */
    public Sample sampleOutput();

    /** Sample by filling out the attribute values of s.
     *  The sampling is to be performed at the time of
     *  s.timestamp
     */
    public Sample sampleOutput(Sample s);
}
