package se.lth.cs.util.byteArrayAccess;

public class ByteArrayAccessFactory {

	public static ByteArrayAccess createByteArrayAccess(byte a[]) {

		if(a[ByteArrayAccess.ENDIANNESS_OFFSET] == ByteArrayAccess.BIG_ENDIAN) {
			return new BigEndian(a);
		} else {
			return new LittleEndian(a);
		}	
	}
}
