
#include <javatypes.h>
#include <gci_common.h>
#include <java_lang_Object.h>

extern struct java_lang_Object_ClassStruct java_lang_Object_Class;


int isInstanceOfClass(void *gc_param_iobj,
		 struct java_lang_Object_ClassStruct *type) {
  GC_PARAM_REF(java_lang_Object, iobj);
    void *eFlag = 0;
    void **__eFlag__ = &eFlag;
  struct java_lang_Object_ClassStruct *objClass;
  GC__GET_THREAD_ROOT;
  GC_PUSH_PARAM(iobj);
  {
    GC_REF(java_lang_Object, obj);
    GC_PUSH_ROOT(obj);
    GC_ASSIGN(obj, iobj);
    GC_GET(objClass, obj, class);

  catch_0:
    GC_POP_ROOT(obj);
  }

  

/*   printf("%x == %x ?\n",objClass,type);  */
  while (objClass != type && objClass != &java_lang_Object_Class) {
    objClass = objClass->super;
/*     printf("%x == %x ?\n",objClass,type);  */
  }

  GC_POP_PARAM(iobj);

  if (objClass == type) {
/*     printf("true\n"); */
    return true;
  } else {
/*     printf("false\n"); */
    return false;
  }

}

int isInstanceOfInterface(void *gc_param_iobj,
		 int iface_index) {
  GC_PARAM_REF(java_lang_Object, iobj);
    void *eFlag = 0;
    void **__eFlag__ = &eFlag;
  struct java_lang_Object_ClassStruct *objClass;
  GC__GET_THREAD_ROOT;
  GC_PUSH_PARAM(iobj);
  {
    GC_REF(java_lang_Object, obj);
    GC_PUSH_ROOT(obj);
    GC_ASSIGN(obj, iobj);
    GC_GET(objClass, obj, class);

    GC_POP_ROOT(obj);
  }
  GC_POP_PARAM(iobj);

  int *arr, i;
  arr = objClass->iface_array;
  for (i=0; i<objClass->iface_size; i++) {
/*     printf("%d == %d ?\n",arr[i],iface_index); */
    if (arr[i] == iface_index) {
      return true;
    }
  }
 catch_0:
  return false;

/*   while (objClass != type && objClass != &java_lang_Object_Class) { */
/* /\*     printf("instanceof\n"); *\/ */
/*     objClass = objClass->super; */
/*   } */



}

int isCompatibleClass(struct java_lang_Object_ClassStruct *class,
		 struct java_lang_Object_ClassStruct *type) {
/*   printf("%x == %x ?\n",objClass,type);  */
  while (class != type && class != &java_lang_Object_Class) {
    class = class->super;
/*     printf("%x == %x ?\n",class,type); */
  }

  if (class == type) {
/*     printf("true\n"); */
    return true;
  } else {
/*     printf("false\n"); */
    return false;
  }

}

