/* $Revision: 1.2 $
 * $Author: sven $
 * $Date: 2003/10/29 14:38:33 $
 */
#include <class_indices.h>

#ifdef JAVA_LANG_DOUBLE_INDEX

#include <javatypes.h>
#include <java_lang_Double.h>
#include <java_lang_String.h>

extern GC_REF(LayoutHead,java_lang_String_Layout);
extern struct java_lang_String_ClassStruct java_lang_String_Class;

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Double_longBitsToDouble_long, JLong i)
GC_FUNC_ENTER;
{
	JDouble* ret = (JDouble*) ((void*) & i);
	GC_RETURN_VAR(*ret);
}
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Double_longBitsToDouble_long)

GC_VAR_FUNC_BEGIN(JLong, java_lang_Double_doubleToLongBits_double, JDouble f)
GC_FUNC_ENTER;
{
	JLong* ret = (JLong*) ((void*) & f);
	GC_RETURN_VAR(*ret);

}
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JLong, java_lang_Double_doubleToLongBits_double)

GC_VAR_FUNC_BEGIN(JLong, java_lang_Double_doubleToRawLongBits_double, JDouble f)
GC_FUNC_ENTER;
{
	JLong* ret = (JLong*) ((void*) & f);
	GC_RETURN_VAR(*ret);
}
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JLong, java_lang_Double_doubleToRawLongBits_double)

GC_REF_FUNC_BEGIN(java_lang_String,java_lang_Double_toString_double,JDouble i)
  GC_FUNC_ENTER
  GC_REF(java_lang_String,s);
  GC_PUSH_ROOT(s);
  {
    char value[26];
    GC_REF(JCharArray, data);
    GC_PUSH_ROOT(data);
    GC_NEW(s,java_lang_String_Layout);
    GC_SET(s,class,&java_lang_String_Class);
    sprintf(value,"%.16g",i);
    GC_REF_FUNC_CALL(data,newJCharArray,strlen(value)+1);
    strcpy((char*) &GC___PTR(data->ref)->data[0],value);

    GC_SET_REF(s,_java_lang_String_value,data);
    GC_SET(s,_java_lang_String_count,strlen(value));

    GC_POP_ROOT(data);
    GC_RETURN_REF(s);
  }
  GC_POP_ROOT(s);
  GC_FUNC_LEAVE;
GC_REF_FUNC_END(java_lang_String ,java_lang_Double_toString_double)


#endif
