#include <class_indices.h>
#ifdef JAVA_LANG_CLASS_INDEX

#include <string.h>
#include <javatypes.h>
#include <reflection.h>
#include <gc.h>
#include <java_lang_String.h>
#include <java_lang_Class.h> 

extern GC__IMPL_REF_DECL(LayoutHead,java_lang_Class_Layout) *java_lang_Class_Layout;
extern struct java_lang_Class_ClassStruct java_lang_Class_Class;
extern struct java_lang_String_ClassStruct java_lang_String_Class;

/*
 * Class VMClass.forName(String)
 */
GC_REF_FUNC_BEGIN(java_lang_Class,java_lang_VMClass_forName_java_lang_String, GC_PARAM(java_lang_String,s))
  GC_PARAM_REF(java_lang_String, s);
  GC_PUSH_PARAM(s);
  GC_FUNC_ENTER
{
/*   strcpy((char*) &GC___PTR(data->ref)->data[0],value); */
  
/*   GC_SET_REF(this,_java_lang_String_value,data); */
/*   GC_SET(this,_java_lang_String_count,strlen(value)); */
  
  char *str,*name;  
  int i=0,slen;
  GC_REF(JCharArray, data);
  GC_PUSH_ALIAS(data);
  GC_GET_REF(data,s,_java_lang_String_value);
  GC_GET(slen,s,_java_lang_String_count);
  str = (char*) &GC___PTR(data->ref)->data[0];
  name = clazzes[i].name;
  while (i<NBR_LIVE_TYPES && (strcmp(clazzes[i].name,str) != 0)) {
/*     printf("* Comparing strings: %s - %s\n",clazzes[i].name,(char*) &GC___PTR(data->ref)->data[0]); */
    name = clazzes[++i].name;
  }
  if (i == NBR_LIVE_TYPES) {
    printf("!!! COULD NOT FIND CLASS %s in loaded classes\n",str);
    printf("!!! Application will likely segfault now\n");
    GC_RETURN_REF(s);
  }
  GC_REF(java_lang_Class, clazz);
  GC_PUSH_ROOT(clazz);
  if (GC_IS_NULL(clazzes[i].clazz)) {
    GC_REF_FUNC_CALL(clazz,java_lang_Class_ClassConstr,
		     &java_lang_Class_Class,GC_PASS(java_lang_Class_Layout));
    GC_SET_REF(clazz,_java_lang_Class_vmdata,s);
    GC_ASSIGN(clazzes[i].clazz, clazz);
  } else {
    GC_ASSIGN(clazz, clazzes[i].clazz);
  }
  GC_RETURN_REF(clazz);
  GC_POP_ROOT(clazz);
  GC_POP_ALIAS(data);
}
GC_FUNC_LEAVE
GC_POP_PARAM(s);
GC_REF_FUNC_END(java_lang_Class,java_lang_VMClass_forName_java_lang_String)

/*
 * String VMClass.getName(String)
 */
GC_REF_FUNC_BEGIN(java_lang_String,java_lang_VMClass_getName_java_lang_Class, GC_PARAM(java_lang_Class,c))
  GC_PARAM_REF(java_lang_Class, c);
  GC_PUSH_PARAM(c);
GC_FUNC_ENTER
{
  GC_REF(java_lang_String,s);
  GC_PUSH_ALIAS(s);
  GC_GET_REF(s,c,_java_lang_Class_vmdata);
  GC_RETURN_REF(s);
  GC_POP_ALIAS(s);
}
GC_FUNC_LEAVE
GC_POP_PARAM(c);
GC_REF_FUNC_END(java_lang_String,java_lang_VMClass_getName_java_lang_Class)



#endif
