/* $Revision: 1.3.2.2 $
 * $Author: sven $
 * $Date: 2004/01/22 13:30:45 $
 */
#include <javatypes.h>
#include <stddef.h>
#include <gc.h>
#include <java_lang_String.h>

#ifndef HOST_RTAI_KERNEL
#include <stdio.h>
#include <sys/time.h>
#endif

GC_VAR_FUNC_BEGIN(JLong,java_lang_System_currentTimeMillis)
  GC_FUNC_ENTER;
  {
    struct timeval tp;
    int time;
#ifndef HOST_RTAI_KERNEL
    gettimeofday(&tp,0);
    time = ((JLong) tp.tv_sec*1000)+((JLong) tp.tv_usec/1000);
    GC_RETURN_VAR(time);
#endif
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,java_lang_System_currentTimeMillis)

GC_PROC_BEGIN(java_lang_System_exit_int,JInt i) 
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  exit(i);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_System_exit_int)

GC_PROC_BEGIN(java_lang_System_registerNatives) 
  GC_FUNC_ENTER
  /* Missing implementation */
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_System_registerNatives)

GC_VAR_FUNC_BEGIN(JInt, java_lang_PhonyReader_read, GC_PARAM(java_lang_PhonyReader, this))
  GC_PARAM_REF(java_lang_PhonyReader, this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
    unsigned char tmp;
    scanf("%c", &tmp);
    GC_RETURN_VAR((int)tmp);
  GC_FUNC_LEAVE
  GC_POP_PARAM(this);
GC_VAR_FUNC_END(Jint, java_lang_PhonyReader_read)

GC_PROC_BEGIN(java_lang_PhonyWriter_print)
  GC_FUNC_ENTER
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print)

GC_PROC_BEGIN(java_lang_PhonyWriter_println) 
  GC_FUNC_ENTER
  printf("\n");
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println)

GC_PROC_BEGIN(java_lang_PhonyWriter_print_int,int i) 
  GC_FUNC_ENTER
  printf("%d",i);
#ifndef HOST_RTAI_KERNEL
  fflush(stdout);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_int) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_int,int i)
  GC_FUNC_ENTER
  printf("%d\n",i);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_int) 

/* GC_PROC_BEGIN(java_lang_PhonyWriter_print_java_lang_String,char* i)  */
/*   GC_FUNC_ENTER */
/*   printf("%s",i); */
/*   GC_FUNC_LEAVE */
/* GC_PROC_END(java_lang_PhonyWriter_print_java_lang_String)  */

/* GC_PROC_BEGIN(java_lang_PhonyWriter_println_java_lang_String,char* i)  */
/*   GC_FUNC_ENTER */
/*   printf("%s\n",i); */
/*   GC_FUNC_LEAVE */
/* GC_PROC_END(java_lang_PhonyWriter_println_java_lang_String)  */

GC_PROC_BEGIN(java_lang_PhonyWriter_print_java_lang_String,GC_PARAM(java_lang_String,s)) 
  GC_PARAM_REF(java_lang_String,s);
  GC_PUSH_PARAM(s);
  GC_FUNC_ENTER;
{  
  GC_REF(JCharArray, data);    
  GC_PUSH_ROOT(data);
  GC_GET_REF(data,s,_java_lang_String_data);

#ifndef HOST_RTAI_KERNEL
  {
    JInt len,i;
    GC_GET(len,data,_JCharA_length);
    for (i=0; i<len; i++) {
      char c;
      c = GC___PTR(data->ref)->data[i].bytes;
      putchar(c);
    }
  }
#else
  printk("%s", GC___PTR(data->ref)->data);
#endif

  GC_POP_ROOT(data);
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_PhonyWriter_print_java_lang_String) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_java_lang_String,GC_PARAM(java_lang_String,s)) 
  GC_PARAM_REF(java_lang_String,s);
  GC_PUSH_PARAM(s);
  GC_FUNC_ENTER;
{  
  GC_REF(JCharArray, data);    
  GC_PUSH_ROOT(data);
  GC_GET_REF(data,s,_java_lang_String_data);
#ifndef HOST_RTAI_KERNEL
  {
    JInt len,i;
    GC_GET(len,data,_JCharA_length);
    for (i=0; i<len; i++) {
      char c;
      c = GC___PTR(data->ref)->data[i].bytes;
      putchar(c);
    }
    putchar('\n');
  }
#else
    printk("%s\n", GC___PTR(data->ref)->data);
#endif

  GC_POP_ROOT(data);
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_PhonyWriter_println_java_lang_String) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_float,float i) 
  GC_FUNC_ENTER
  printf("%f",i);
#ifndef HOST_RTAI_KERNEL
  fflush(stdout);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_float) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_float,float i)
  GC_FUNC_ENTER
  printf("%f\n",i);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_float) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_short,short i) 
  GC_FUNC_ENTER
  printf("%d",i);
#ifndef HOST_RTAI_KERNEL
  fflush(stdout);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_short) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_short,short i)
  GC_FUNC_ENTER
  printf("%d\n",i);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_short) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_char,char i) 
  GC_FUNC_ENTER
  printf("%c",i);
#ifndef HOST_RTAI_KERNEL
  fflush(stdout);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_char) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_char,char i)
  GC_FUNC_ENTER
  printf("%c\n",i);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_char) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_long,long long i) 
  GC_FUNC_ENTER
  printf("%lld",i);
#ifndef HOST_RTAI_KERNEL
  fflush(stdout);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_long) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_long,long long i)
  GC_FUNC_ENTER
  printf("%lld\n",i);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_long) 


GC_PROC_BEGIN(java_lang_PhonyWriter_print_boolean,short i) 
  GC_FUNC_ENTER
  if (i) {
    printf("true");
  } else {
    printf("false");
  }
#ifndef HOST_RTAI_KERNEL
  fflush(stdout);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_boolean) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_boolean,short i)
  GC_FUNC_ENTER
  if (i) {
    printf("true\n");
  } else {
    printf("false\n");
  }
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_boolean) 

JInt java_lang_System_identityHashCode_java_lang_Object(void* o) {
  return (JInt) o;
}

void java_lang_System_arraycopy_java_lang_Object_int_java_lang_Object_int_int(void* src, int src_pos, 
							   void* dest, int dest_pos,
							   int length) {
  /* Implementation missing !! */
}

GC_PROC_BEGIN(java_lang_ErrWriter_print)
  GC_FUNC_ENTER
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_print)

GC_PROC_BEGIN(java_lang_ErrWriter_println) 
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  fprintf(stderr,"\n");
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_println)

GC_PROC_BEGIN(java_lang_ErrWriter_print_int,int i) 
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  fprintf(stderr,"%d",i);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_print_int) 

GC_PROC_BEGIN(java_lang_ErrWriter_print_java_lang_String,char* i) 
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  fprintf(stderr,"%s",i);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_print_java_lang_String) 

GC_PROC_BEGIN(java_lang_ErrWriter_println_int,int i)
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  fprintf(stderr,"%d\n",i);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_println_int) 

GC_PROC_BEGIN(java_lang_ErrWriter_println_java_lang_String,char* i) 
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  fprintf(stderr,"%s\n",i);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_println_java_lang_String) 

GC_PROC_BEGIN(java_lang_ErrWriter_print_float,float i) 
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  fprintf(stderr,"%f",i);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_print_float) 

GC_PROC_BEGIN(java_lang_ErrWriter_println_float,float i)
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  fprintf(stderr,"%f\n",i);
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_println_float) 

GC_PROC_BEGIN(java_lang_ErrWriter_print_boolean,short i) 
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  if (i) {
    fprintf(stderr,"true");
  } else {
    fprintf(stderr,"false");
  }
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_print_boolean) 

GC_PROC_BEGIN(java_lang_ErrWriter_println_boolean,short i)
  GC_FUNC_ENTER
#ifndef HOST_RTAI_KERNEL
  if (i) {
    fprintf(stderr,"true\n");
  } else {
    fprintf(stderr,"false\n");
  }
#endif
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_ErrWriter_println_boolean) 

