#ifndef ___COMPILED_H
#define ___COMPILED_H

#include <javatypes.h>

#include <gc.h>

#include <gci_common.h>

#include <exception.h>

#include <java_lang_System.h>

struct _TestThread_ClassStruct {
  /* Super class struct pointer */
  struct _TestThread_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
};
typedef GC_STRUCT_BEGIN(_TestThread)
  GC_STRUCT_VAR(struct _TestThread_ClassStruct *,class);
  volatile GC_STRUCT_VAR(JLong,target);
  volatile GC_STRUCT_VAR(JInt,a);
GC_STRUCT_END(_TestThread) _TestThread;

struct se_lth_cs_sven_Thread_ClassStruct {
  /* Super class struct pointer */
  struct se_lth_cs_sven_Thread_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
};

typedef GC_STRUCT_BEGIN(se_lth_cs_sven_Thread)
  GC_STRUCT_VAR(struct se_lth_cs_sven_Thread_ClassStruct *,class);
  volatile GC_STRUCT_VAR(JLong,target);
GC_STRUCT_END(se_lth_cs_sven_Thread) se_lth_cs_sven_Thread;

struct se_lth_cs_sven_PeriodicThread_ClassStruct {
  /* Super class struct pointer */
  struct se_lth_cs_sven_PeriodicThread_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
};

typedef GC_STRUCT_BEGIN(se_lth_cs_sven_PeriodicThread)
  GC_STRUCT_VAR(struct se_lth_cs_sven_PeriodicThread_ClassStruct *,class);
  volatile GC_STRUCT_VAR(JLong,target);
  volatile GC_STRUCT_VAR(JLong,deadline);
  volatile GC_STRUCT_VAR(JLong,period);
  volatile GC_STRUCT_VAR(JBoolean,interruptedFlag);
GC_STRUCT_END(se_lth_cs_sven_PeriodicThread) se_lth_cs_sven_PeriodicThread;
struct se_lth_cs_sven_PeriodicThread_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
  void (*sleep_long)(JLong);
  void (*start)(REF(struct se_lth_cs_sven_Thread));
  void (*start_lp)(REF(struct se_lth_cs_sven_Thread));
  void (*run)(REF(struct se_lth_cs_sven_PeriodicThread));
  void (*setDeadline_long)(REF(struct se_lth_cs_sven_PeriodicThread),JLong);
  void (*setPeriod_long)(REF(struct se_lth_cs_sven_PeriodicThread),JLong);
  void (*native_run_long_long)(REF(struct se_lth_cs_sven_PeriodicThread),JLong,JLong);
  void (*perform)(REF(struct se_lth_cs_sven_PeriodicThread));
  void (*interrupt)(REF(struct se_lth_cs_sven_PeriodicThread));
}se_lth_cs_sven_PeriodicThread_MethodTbl ;



struct java_lang_Object_ClassStruct {
  /* Super class struct pointer */
  struct java_lang_Object_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
};

typedef GC_STRUCT_BEGIN(java_lang_Object)
  GC_STRUCT_VAR(struct java_lang_Object_ClassStruct *,class);
GC_STRUCT_END(java_lang_Object) java_lang_Object;

struct java_lang_System_ClassStruct {
  /* Super class struct pointer */
  struct java_lang_System_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
  volatile GC_STRUCT_REF(java_lang_System_PhonyWriter,out);
};

typedef GC_STRUCT_BEGIN(java_lang_System)
  GC_STRUCT_VAR(struct java_lang_System_ClassStruct *,class);
GC_STRUCT_END(java_lang_System) java_lang_System;

struct java_lang_String_ClassStruct {
  /* Super class struct pointer */
  struct java_lang_String_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
  volatile GC_STRUCT_VAR(JLong,serialVersionUID);
};

typedef GC_STRUCT_BEGIN(java_lang_String)
  GC_STRUCT_VAR(struct java_lang_String_ClassStruct *,class);
  volatile GC_STRUCT_REF(java_lang_Object,data);
  volatile GC_STRUCT_VAR(JInt,boffset);
  volatile GC_STRUCT_VAR(JInt,count);
GC_STRUCT_END(java_lang_String) java_lang_String;

struct java_lang_InterruptedException_ClassStruct {
  /* Super class struct pointer */
  struct java_lang_InterruptedException_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
  volatile GC_STRUCT_VAR(JBoolean,trace_enabled);
  volatile GC_STRUCT_VAR(JLong,serialVersionUID);
};

typedef GC_STRUCT_BEGIN(java_lang_InterruptedException)
  GC_STRUCT_VAR(struct java_lang_InterruptedException_ClassStruct *,class);
  volatile GC_STRUCT_REF(java_lang_String,detailMessage);
  volatile GC_STRUCT_VAR(JByte,stackTrace);
GC_STRUCT_END(java_lang_InterruptedException) java_lang_InterruptedException;

struct java_lang_Exception_ClassStruct {
  /* Super class struct pointer */
  struct java_lang_Exception_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
  volatile GC_STRUCT_VAR(JBoolean,trace_enabled);
  volatile GC_STRUCT_VAR(JLong,serialVersionUID);
};

typedef GC_STRUCT_BEGIN(java_lang_Exception)
  GC_STRUCT_VAR(struct java_lang_Exception_ClassStruct *,class);
  volatile GC_STRUCT_REF(java_lang_String,detailMessage);
  volatile GC_STRUCT_VAR(JByte,stackTrace);
GC_STRUCT_END(java_lang_Exception) java_lang_Exception;

struct java_lang_Throwable_ClassStruct {
  /* Super class struct pointer */
  struct java_lang_Throwable_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
  volatile GC_STRUCT_VAR(JBoolean,trace_enabled);
  volatile GC_STRUCT_VAR(JLong,serialVersionUID);
};

typedef GC_STRUCT_BEGIN(java_lang_Throwable)
  GC_STRUCT_VAR(struct java_lang_Throwable_ClassStruct *,class);
  volatile GC_STRUCT_REF(java_lang_String,detailMessage);
  volatile GC_STRUCT_VAR(JByte,stackTrace);
GC_STRUCT_END(java_lang_Throwable) java_lang_Throwable;

struct _TestThread_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
  void (*sleep_long)(JLong);
  void (*start)(REF(struct se_lth_cs_sven_Thread));
  void (*start_lp)(REF(struct se_lth_cs_sven_Thread));
  void (*run)(REF(struct _TestThread));
}_TestThread_MethodTbl ;

struct se_lth_cs_sven_Thread_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
  void (*sleep_long)(JLong);
  void (*start)(REF(struct se_lth_cs_sven_Thread));
  void (*start_lp)(REF(struct se_lth_cs_sven_Thread));
  void (*run)(REF(struct se_lth_cs_sven_Thread));
}se_lth_cs_sven_Thread_MethodTbl ;

struct java_lang_Object_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
}java_lang_Object_MethodTbl ;

struct java_lang_System_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
  void (*arraycopy_Object_int_Object_int_int)(REF(struct java_lang_Object),JInt,REF(struct java_lang_Object),JInt,JInt);
  JLong (*currentTimeMillis)();
  JInt (*identityHashCode_Object)(REF(struct java_lang_Object));
}java_lang_System_MethodTbl ;

struct java_lang_String_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
}java_lang_String_MethodTbl ;

struct java_lang_InterruptedException_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
  REF(struct java_lang_String) (*getLocalizedMessage)(REF(struct java_lang_Throwable));
  REF(struct java_lang_String) (*getMessage)(REF(struct java_lang_Throwable));
}java_lang_InterruptedException_MethodTbl ;

struct java_lang_Exception_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
  REF(struct java_lang_String) (*getLocalizedMessage)(REF(struct java_lang_Throwable));
  REF(struct java_lang_String) (*getMessage)(REF(struct java_lang_Throwable));
}java_lang_Exception_MethodTbl ;

struct java_lang_Throwable_MethodTblStruct {
  /* Method pointers, static and non-static */
  JInt (*hashCode)(REF(struct java_lang_Object));
  void (*notify)(REF(struct java_lang_Object));
  void (*notifyAll)(REF(struct java_lang_Object));
  JBoolean (*equals_Object)(REF(struct java_lang_Object),REF(struct java_lang_Object));
  REF(struct java_lang_String) (*toString)(REF(struct java_lang_Object));
  REF(struct java_lang_String) (*getLocalizedMessage)(REF(struct java_lang_Throwable));
  REF(struct java_lang_String) (*getMessage)(REF(struct java_lang_Throwable));
}java_lang_Throwable_MethodTbl ;

#endif
