#include <gc.h>
#include <Kernel.h>

// HERE BE DRAGONS! We need to know how a struct _Thread_ClassStruct looks
// in order to find the run method. This could maybe be fixed with a
// aux function getMethodPointer(char *className, char *methodName) or
// something like that.
// For now, we require that a (manually created) Thread.h exists
// #include "_PeriodicThread.h"
#include "compiled.h"

GC_PROC_BEGIN(_se_lth_cs_sven_PeriodicThread_native_run_long_long,GC_PARAM(se_lth_cs_sven_PeriodicThread,this),long deadline, long period)
GC_PARAM_REF(se_lth_cs_sven_PeriodicThread, this);
GC_PUSH_PARAM(this);
GC_FUNC_ENTER;
{
	Times_Time nextDeadline;
	Times_Time nextWake;
	JBoolean intr;

	struct se_lth_cs_sven_PeriodicThread_ClassStruct *_tmp_method;
	GC_GET(_tmp_method,this,class);
	GC_GET(intr,this,interruptedFlag);

	nextWake = Times_Now();
	nextDeadline = Times_Add(nextWake, Times_SecondsToDuration(((double)deadline)/1000));
	LCS_SetDeadline(nextDeadline);
	while(!intr) {
		JLong javaDL;
		JLong javaP;

		GC_GET(javaP, this, period);
		//cprintf("_se_lth_cs_sven_PeriodicThread_native_run (%ld,%ld)\n",deadline, period);
		// cprintf("_se_lth_cs_sven_PeriodicThread_native_run \n");
		//nextWake = nextDeadline;
		nextWake = Times_Add(nextWake, Times_SecondsToDuration(((double)javaP)/1000));
		nextDeadline = Times_Add(nextDeadline, Times_SecondsToDuration(((double)javaP)/1000));
      		GC_PROC_CALL(_tmp_method->methodTbl->perform, GC_PASS(this));
		LCS_SetDeadlineAndWaitUntil(nextDeadline, nextWake);
		GC_GET(intr,this,interruptedFlag);
        }
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_sven_PeriodicThread_native_run_long_long)

