#ifndef AVR_LCD_H
#define AVR_LCD_H

#include <stdint.h>

#include "AVR_Types.h"

#define RW	_BV(2)
#define RS	_BV(0)
#define ENABLE	_BV(3)

void LCD_moveCursor(uint8_t);
void LCD_enableCursor();
void LCD_disableCursor();
void LCD_writeDataByte(uint8_t);
void LCD_writeCtrlByte(uint8_t);
void LCD_setupPorts();
void LCD_DelayMS(int);
void LCD_clear();
void LCD_printChar(char);
void LCD_printByte(uint8_t);
void LCD_printInt(uint16_t);
void LCD_printInt32(uint32_t);
void LCD_printStr(const char*);

#endif
