#ifndef AVR_QUEUE_H
#define AVR_QUEUE_H

#include "AVR_Types.h"

void		queue_init(queue_t*);

/* Priority Queue: sorted by priority */
void		pq_insert(queue_t*, kthread_t*);
kthread_t*	pq_pop_one(queue_t*);
kthread_t*	pq_pop_group(queue_t*);

/* Time Queue: sorted by time and priority */
void		tq_insert(queue_t*, kthread_t*);
kthread_t*	tq_pop_one(queue_t*);

#endif
