#include <avr/interrupt.h>
#include <compat/ina90.h>
#include <gc.h>
#include <javatypes.h>
#include <java_lang_Object.h>

#include "AVR_LCD.h"

extern void java_main()
{
	void *eFlag = 0;
	void **__eFlag__ = &eFlag;

	cli();
	GC_THREAD_INIT;
	GC__GET_THREAD_ROOT;
	sei();

	GC_REF(RefArray, args);
	GC_PUSH_ROOT(args);

	GC_REF_FUNC_CALL(args, newRefArray, 0);
	GC_PROC_CALL(JAVAMAIN, args);

	GC_POP_ROOT(args);

	cli();
	GC_THREAD_EXIT;
}

GC_PROC_BEGIN(ljrt_monitor_init,GC_PARAM(java_lang_Object,this))
	/* not implemented */
	cli();
	LCD_clear();
	LCD_printStr("monitor not impl");
	while (1) _NOP();
GC_PROC_END(ljrt_monitor_init)

GC_PROC_BEGIN(ljrt_monitor_enter,GC_PARAM(java_lang_Object,this))
	/* not implemented */
	cli();
	LCD_clear();
	LCD_printStr("monitor not impl");
	while (1) _NOP();
GC_PROC_END(ljrt_monitor_enter)

GC_PROC_BEGIN(ljrt_monitor_leave,GC_PARAM(java_lang_Object,this))
	/* not implemented */
	cli();
	LCD_clear();
	LCD_printStr("monitor not impl");
	while (1) _NOP();
GC_PROC_END(ljrt_monitor_leave)

void ljrt_monitor_free(java_lang_Object* this)
{
	/* not implemented */
	cli();
	LCD_clear();
	LCD_printStr("monitor not impl");
	while (1) _NOP();
}

