#include <class_indices.h>

#ifdef SE_LTH_CS_REALTIME_SEMAPHORE_COUNTINGSEM_INDEX

#include <javatypes.h>
#include <gc.h>
#include <se_lth_cs_realtime_semaphore_CountingSem.h>

#include "AVR_Semaphore.h"

GC_VAR_FUNC_BEGIN(JInt,se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),JInt iValue)
	GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER;
{
	semaphore_t* sem;
	sem = new_semaphore((int) iValue);

	GC_RETURN_VAR((JInt) sem);
}
	GC_FUNC_LEAVE;
	GC_POP_PARAM(this);
GC_VAR_FUNC_END(JInt,se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),JInt target)
	GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER;
{
	semaphore_give((semaphore_t*) target);
}
	GC_FUNC_LEAVE;
	GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),JInt target)
	GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER;
{
	semaphore_take((semaphore_t*) target);
}
	GC_FUNC_LEAVE;
	GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_int)

#endif
