#include <class_indices.h>

#ifdef SE_LTH_CS_REALTIME_SEMAPHORE_MUTEXSEM_INDEX

#include <javatypes.h>
#include <gc.h>
#include <se_lth_cs_realtime_semaphore_MutexSem.h>

#include "AVR_Semaphore.h"

GC_VAR_FUNC_BEGIN(JInt,se_lth_cs_realtime_semaphore_MutexSem_createMutexSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JInt iValue)
	GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER;
{
	mutex_t* mutex;
	mutex = new_mutex();

	GC_RETURN_VAR((JInt) mutex);
}
	GC_FUNC_LEAVE;
	GC_POP_PARAM(this);
GC_VAR_FUNC_END(JInt,se_lth_cs_realtime_semaphore_MutexSem_createMutexSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_MutexSem_giveMutexSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JInt target)
	GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER;
{
	mutex_give((mutex_t*) target);
}
	GC_FUNC_LEAVE;
	GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_MutexSem_giveMutexSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_MutexSem_takeMutexSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_MutexSem,this),JInt target)
	GC_PARAM_REF(se_lth_cs_realtime_semaphore_MutexSem,this);
	GC_PUSH_PARAM(this);
	GC_FUNC_ENTER;
{
	mutex_take((mutex_t*) target);
}
	GC_FUNC_LEAVE;
	GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_MutexSem_takeMutexSem_int)

#endif
