  .global interrupt0
interrupt0:
;   push  r25
;   lds    r25, SREG
;   push  r25
;   lds	r25, EIMSK
;   push	r25
;   lds	r25, TIMSK
;   push	r25
;   push  r28
;   push  r29

;   push  r24
;   push  r26
;   push  r27
;   push  r30
;   push  r31
;   push  r0
;   push  r1
;   push  r2
;   push  r3
;   push  r4
;   push  r5
;   push  r6
;   push  r7
;   push  r8
;   push  r9
;   push  r10
;   push  r11
;   push  r12
;   push  r13
;   push  r14
;   push  r15
;   push  r16
;   push  r17
;   push  r18
;   push  r19
;   push  r20
;   push  r21
;   push  r22
;   push  r23


; Move interrupt processes to ready state

intWakeupLoop:	
  lds	r24, intQueue0
  lds	r25, intQueue0+1
  call	prioQueueRemoveMulti
  ldi	r18, 0x00
  cp	r24, r18
  cpc	r25, r18
  breq	intNoMoreToWakeUp
  ;mov   r22, r24
  ;mov   r23, r25
  call	readyQueueInsertLast
  rjmp	intWakeupLoop
intNoMoreToWakeUp:	

  pop   r23
  pop   r22
  pop   r21
  pop   r20
  pop   r19
  pop   r18
  pop   r17
  pop   r16
  pop   r15
  pop   r14
  pop   r13
  pop   r12
  pop   r11
  pop   r10
  pop   r9
  pop   r8
  pop   r7
  pop   r6
  pop   r5
  pop   r4
  pop   r3
  pop   r2
  pop   r1
  pop   r0
  pop   r31
  pop   r30
  pop   r27
  pop   r26
  pop   r24
  
  pop   r29
  pop   r28

  pop	r25
  sts	TIMSK, r25
  pop	r25
  sts	EIMSK, r25
  pop   r25
  sts   SREG, r25

  pop   r25
  reti

