/* $Revision: 1.1.2.2 $
 * $Author: andersn $
 * $Date: 2004/03/06 10:46:14 $
 */
#include <javatypes.h>
//#include <sys/time.h>
#include <stddef.h>
#include <gc.h>
/* #define INT_MAX 32767 */
/* #include <stdio.h> */
//#include <pthread.h>
#include <java_lang_Thread.h>
#include <java_lang_String.h>

//#include <rtai.h>
#include <xenomai/native/timer.h>
#include <xenomai/native/task.h>
//#include <rtai_sched.h>
//#include <rtai_types.h>

GC_PROC_BEGIN(se_lth_cs_realtime_RTSystem_sleepUntil_long,JLong micros)
  GC_FUNC_ENTER
  {
    rt_task_sleep_until((micros*1000000));
  }
  GC_FUNC_LEAVE
GC_PROC_END(se_lth_cs_realtime_RTSystem_sleepUntil_long)


GC_PROC_BEGIN(se_lth_cs_realtime_RTSystem_sleepUntilMicros_long,JLong micros)
  GC_FUNC_ENTER
  {
    rt_task_sleep_until((micros*1000));
  }
  GC_FUNC_LEAVE
GC_PROC_END(se_lth_cs_realtime_RTSystem_sleepUntil_long)


GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_RTSystem_currentTimeMillis)
  GC_FUNC_ENTER;
  {
    JLong time;
#ifndef HOST_RTAI_KERNEL
    time = rt_timer_read() / (JLong) 1E6;
#else
    // HERE BE DRAGONS! hack to avoid undefined __divdi3
     time = rt_timer_read() >> 20 ;
//    time = rt_timer_read() / 1E6;
#endif
    GC_RETURN_VAR(time);
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_RTSystem_currentTimeMillis)

GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_RTSystem_currentTimeMicros)
  GC_FUNC_ENTER;
  {
    JLong time;
/* #ifndef HOST_RTAI_KERNEL */
    time = rt_timer_read() / 1000;
/* #else */
/*     // HERE BE DRAGONS! hack to avoid undefined __divdi3 */
/*      time = rt_timer_read() >> 10 ; */
/* #endif */
    GC_RETURN_VAR(time);
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_RTSystem_currentTimeMicros)

	
// Feedback Schedule Extension
#if 0	
GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_RTSystem_getRuntime_java_lang_Thread_int, GC_PARAM(java_lang_Thread, t), JInt nbr)
 GC_PARAM_REF(java_lang_Thread, t);
 GC_PUSH_PARAM(t);
 GC_FUNC_ENTER
 	RT_TASK *task;
	RT_TASK_INFO i;
	
	GC_GET(task, t, _java_lang_Thread_target);
	rt_task_inquire(task, &i);
	
	GC_RETURN_VAR(i.runtime_buf[nbr]);
 GC_FUNC_LEAVE
 GC_POP_PARAM(t);
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_RTSystem_getRuntime_java_lang_Thread_int)

GC_VAR_FUNC_BEGIN(JLong,se_lth_cs_realtime_RTSystem_getEndtime_java_lang_Thread_int, GC_PARAM(java_lang_Thread, t), JInt nbr)
 GC_PARAM_REF(java_lang_Thread, t);
 GC_PUSH_PARAM(t);
 GC_FUNC_ENTER
 	RT_TASK *task;
	RT_TASK_INFO i;

	GC_GET(task, t, _java_lang_Thread_target);
	rt_task_inquire(task, &i);
	
	GC_RETURN_VAR(i.endtime_buf[nbr]);
 GC_FUNC_LEAVE
 GC_POP_PARAM(t);
GC_VAR_FUNC_END(JLong,se_lth_cs_realtime_RTSystem_getEndtime_java_lang_Thread_int)
		
GC_VAR_FUNC_BEGIN(JInt,se_lth_cs_realtime_RTSystem_getTimeBufferSize_java_lang_Thread, GC_PARAM(java_lang_Thread, t))
 GC_PARAM_REF(java_lang_Thread, t);
 GC_PUSH_PARAM(t);
 GC_FUNC_ENTER
#warning "***** se.lth.cs.realtime.RTSystem.getRuntime not implemented *****"
#if 0
 	RT_TASK *task;
	RT_TASK_INFO i;

	GC_GET(task, t, _java_lang_Thread_target);
	rt_task_inquire(task, &i);
//	printf("EndTime: %llu, RunTime: %llu\n", i.endtime_buf[0], i.runtime_buf[0]);
	GC_RETURN_VAR(i.runtime_buf[0]);
#endif
 GC_FUNC_LEAVE
 GC_POP_PARAM(t);
GC_VAR_FUNC_END(JInt,se_lth_cs_realtime_RTSystem_getTimeBufferSize_java_lang_Thread)	
#endif

