import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;


public class HostConnect extends JFrame implements ActionListener {

	private JTextField address;
	private JButton accept;
	private JButton cancel;
	private int nextCam = 0;
	private GUI gui;

	public HostConnect(GUI gui) {
		super("Connect to Host");

		this.gui = gui;

		accept = new JButton("Accept");
		accept.addActionListener(this);

		cancel = new JButton("Cancel");
		cancel.addActionListener(this);

		address = new JTextField();
		address.setText("argus-1:3800");
		address.setEnabled(true);

		this.getContentPane().setLayout(new BorderLayout());
		this.getContentPane().add(address, BorderLayout.NORTH);
		this.getContentPane().add(accept, BorderLayout.WEST);
		this.getContentPane().add(cancel, BorderLayout.EAST);
		this.setLocationRelativeTo(null);
		this.pack();
		this.setVisible(true);
	}

	public void actionPerformed(ActionEvent a) {

		if ("Accept".equals(a.getActionCommand())) {
			String addr = address.getText().trim();
			ImageFrame imgframe = new ImageFrame(gui, addr);
		}

		setVisible(false);
		dispose();
	}
}
