import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

class ImagePanel extends JPanel {
	ImageIcon icon;

	public ImagePanel() {
		super();
		icon = new ImageIcon();
		JLabel label = new JLabel(icon);
		add(label);
		this.setPreferredSize(new Dimension(320, 240));
    }

	public void setImage(byte[] data) {
		Image theImage = getToolkit().createImage(data);
		getToolkit().prepareImage(theImage, -1, -1, null);	    
		icon.setImage(theImage);
		icon.paintIcon(this, this.getGraphics(), 0, 0);
	}
}
