import java.net.*;

class Server {

	public static void main(String[] args) {
		if (args.length < 1) {
			System.out.println("too few arguments");
			System.out.println("java Server <port>");
			System.exit(1);
		}

		int port = Integer.parseInt(args[0]);

		//InetSocketAddress addr = new InetSocketAddress("www.google.se", 80);
		DatagramSocket socket;
		DatagramPacket packet;

		try {

			System.out.println("Creating Datagram socket...");
			socket = new DatagramSocket(port);

			while (true) {

				System.out.println("Waiting for client...");
				byte[] buff = new byte[256];
				packet = new DatagramPacket(buff, buff.length);
				socket.receive(packet);
				System.out.print("Message was: ");
				buff = packet.getData();
				for (int i = 0; i < buff.length; ++i) {
					if (buff[i] == 0) break;
					System.out.print((char)buff[i]);
 				}
				System.out.println("");

				System.out.println("Sending response...");
				InetAddress addr = packet.getAddress();
				port = packet.getPort();
				byte[] data = new byte[] {'b', '0', 'r', 'k'};
				packet = new DatagramPacket(data, data.length, addr, port);
				socket.send(packet);
			}
		} catch (Exception e) {}
	}
}
