import se.lth.cs.realtime.*;

public class FixPrioOpt extends Thread
implements FixedPriority 
{

    long fib(int n) {
	return n<2 ? 1 : fib(n-2)+fib(n-1);
    }

    double scalar(double[] a, double[] b) {
	double res = 0;
	int len = a.length;
	for (int i=0; i<len; i++) {
	    res += a[i]*b[i];
	}
	return res;
    }

    void testScalar() {
 	double a[] = new double[6];
 	double b[] = new double[6];
 	a[0] = 1.2;
 	a[1] = 1.2;
 	a[2] = 1.2;
 	a[3] = 1.2;
 	a[4] = 1.2;
 	a[5] = 1.2;
 	b[0] = 1.2;
 	b[1] = 1.2;
 	b[2] = 1.2;
 	b[3] = 1.2;
 	b[4] = 1.2;
 	b[5] = 1.2;
	
	double res = scalar(a,b);
    }

    public void run() {
	long t;
	System.out.println("Running testScalar");
	t = System.currentTimeMillis();
	for (int i=0; i<10000; i++) {
	    testScalar();
	}
	System.out.print("Time used: ");
	System.out.println(System.currentTimeMillis()-t);
	double res;
	System.out.println("Running fib");
	t = System.currentTimeMillis();
	res = fib(30);
	System.out.print("Time used: ");
	System.out.println(System.currentTimeMillis()-t);
    }

    static void testa() {}

    public static void main(String[] args) {
	System.out.println("hello");

	Fix
	testa();

	FixPrioOpt fix = new FixPrioOpt();
	fix.start();

    }
}