package regtest;

public class ConstTest extends TestCase {
	private static int errCount = 0;
	
	public static int testAll() {
		System.out.println("  ConstTest start");
		testInteger();
		testFloat();
		System.out.println("  ConstTest finished");
		return errCount;
	}

	private static void testInteger() {
		int i = 0;

		i += 3 + 4;
		errCount += check(i == 7,
				"    testInteger failed(1)");

		i = 3 - 4;
		errCount += check(i == -1,
				"    testInteger failed(2)");

		i = 3 * 4;
		errCount += check(i == 12,
				"    testInteger failed(3)");

		i = 3 / 4;
		errCount += check(i == 0,
				"    testInteger failed(4)");

		i = 4 / 3;
		errCount += check(i == 1,
				"    testInteger failed(5)");
	}

	private static void testFloat() {
	}
};
