
import se.lth.cs.realtime.RTThread;
import se.lth.cs.realtime.event.*;

public class REX_Boss extends RTThread {

	private REX_Worker[] workerList;
	private int count;
	private long sleepTime;
	
	public REX_Boss(String name, long sleepTime, REX_Worker[] workerList) {
		super(name);
		this.workerList = workerList;
		this.sleepTime = sleepTime;
		count = 0;
	}
	
	public void perform() {
		REX_MeetingEvent evt = new REX_MeetingEvent();
		evt.entry(workerList[count % workerList.length]);
		count++;
		sleep(sleepTime);
	}
}
