#!/bin/bash

cd .. && make clean && make && cd build

# pthread build with ncurses - for testing on x86
#export LDFLAGS=-lncurses
#make clean && ../configure --with-thread=pthread --enable-sourcelines && make

# simulavr build
#make clean && ../configure --host=avr-atmel-elf --with-gc=nonmoving --with-heapsize=22048 --with-thread=tobbe --disable-gc-finalizers --with-exceptions=none --enable-verbose --enable-sourcelines && make rom

# nonmoving build - use this for AVR
make clean && ../configure --host=avr-atmel-elf --with-gc=nonmoving --with-heapsize=22048 --with-thread=tobbe --disable-gc-finalizers --enable-avr-external-clock --with-exceptions=none --enable-verbose --enable-sourcelines && make rom

# UISP upload command. Obsolete.
#uisp -dprog=stk200 -dlpt=0x378 --erase --upload if=Main.rom

