#include <AVR_LCD.h>
#include <javatypes.h>

GC_PROC_BEGIN(done_LCD_moveCursor_int, JInt pos)
     GC_FUNC_ENTER;
{
  LCD_moveCursor((int)pos);
}
GC_FUNC_LEAVE
GC_PROC_END(done_LCD_moveCursor_int)

GC_PROC_BEGIN(done_LCD_enableCursor)
     GC_FUNC_ENTER;
{
  LCD_enableCursor();
}
GC_FUNC_LEAVE
GC_PROC_END(done_LCD_enableCursor)

GC_PROC_BEGIN(done_LCD_disableCursor)
     GC_FUNC_ENTER;
{
  LCD_disableCursor();
}
GC_FUNC_LEAVE
GC_PROC_END(done_LCD_disableCursor)

GC_PROC_BEGIN(done_LCD_clear)
     GC_FUNC_ENTER;
{
  LCD_clear();
}
GC_FUNC_LEAVE
GC_PROC_END(done_LCD_clear)

GC_PROC_BEGIN(done_LCD_print_char, JChar c)
     GC_FUNC_ENTER;
{
  LCD_printChar(c);
}
GC_FUNC_LEAVE
GC_PROC_END(done_LCD_print_char)

GC_PROC_BEGIN(done_LCD_print_byte, JByte b)
     GC_FUNC_ENTER;
{
  LCD_printByte(b);
}
GC_FUNC_LEAVE
GC_PROC_END(done_LCD_print_byte)

GC_PROC_BEGIN(done_LCD_print_short, JShort i)
     GC_FUNC_ENTER;
{
  LCD_printInt32((uint16_t)i);
}
GC_FUNC_LEAVE
GC_PROC_END(done_LCD_print_short)

GC_PROC_BEGIN(done_LCD_print_int, JInt i)
     GC_FUNC_ENTER;
{
  LCD_printInt32((uint32_t)i);
}
GC_FUNC_LEAVE
GC_PROC_END(done_LCD_print_int)

