/* $Revision: 1.1.2.2 $
 * $Author: andersn $
 * $Date: 2004/05/31 19:57:37 $
 */
#include <javatypes.h>
#include <sys/time.h>
#include <stddef.h>
#include <gc.h>
#include <gci_common.h>
#include <stdio.h>
#include <pthread.h>

GC_VAR_FUNC_BEGIN(JLong,RTSystem_currentTimeMillis)
  GC_FUNC_ENTER;
  {
    struct timeval tp;
    int time;
    gettimeofday(&tp,0);
    time = ((JLong) tp.tv_sec*1000)+((JLong) tp.tv_usec/1000);
    GC_RETURN_VAR(time);
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,RTSystem_currentTimeMillis)

GC_VAR_FUNC_BEGIN(JLong,RTSystem_currentTimeMicros)
  GC_FUNC_ENTER;
  {
    struct timeval tp;
    int time;
    gettimeofday(&tp,0);
    time = ((JLong) tp.tv_sec*1000000)+((JLong) tp.tv_usec);
    GC_RETURN_VAR(time);
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,RTSystem_currentTimeMicros)

GC_PROC_BEGIN(RTSystem_sleepUntil_long,JLong micros)
  GC_FUNC_ENTER
  {

    struct timeval tp;
    int time;
    gettimeofday(&tp,0);
    time = ((JLong) tp.tv_sec*1000000)+((JLong) tp.tv_usec);

    GC_PROC_CALL(java_lang_Thread_sleep_long,(micros-time)/1000);

  }
  GC_FUNC_LEAVE
GC_PROC_END(RTSystem_sleepUntil_long)

