
import se.lth.cs.realtime.*;

public class PeriodSuspThread extends PeriodicThread {

	private PeriodicThread target;
	private int count;
	private boolean doSuspend;
	
	public PeriodSuspThread(String name, PeriodicThread target, long sleepTime) {
			super(name, sleepTime);
	
		this.target = target;
		count = 0;
		doSuspend = true;
	}
	
	public void perform() {
			if (count % 4 == 0) {
				if (doSuspend) {
					doSuspend = false;
					System.out.println(getName() + "\tSUSPEND " + target.getName());
					target.suspend();
				} else {
					System.out.println(getName() + "\tRESUME " + target.getName());
					target.resume();
					doSuspend = true;
				}
			}
	
			count++;
	}
}
