import se.lth.cs.util.byteArrayAccess.*;

public class FooParamAccess {

	private ByteArrayAccess baa;
	private int index;
	private final int p_base = 20;
	private final int p_size = 8;
	private final int K_offset = 0;
	private final int Ti_offset = 4;

	public FooParamAccess(ByteArrayAccess baa, int i) {
		this.baa = baa;
		index = i;
	}

	public final float K(){
		int base = p_base + p_size*index + K_offset;
		return baa.getFloat(base);
	}

	public final void setK(float val){
		int base = p_base + p_size*index + K_offset;
		baa.setFloat(base, val);
	}

	public final float Ti(){
		int base = p_base + p_size*index + Ti_offset;
		return baa.getFloat(base);
	}

	public final void setTi(float val){
		int base = p_base + p_size*index + Ti_offset;
		baa.setFloat(base, val);
	}
}
