class A extends Thread {

	int id;
	
	public void run() {
		try {
			sleep(100);		
		} catch (InterruptedException e) {
			System.out.println("Sleep interrupted!");
		}
	}
	
	public static void main(String[] args) {
		A th1;
		A th2;

		th1 = new A();
		th2 = new A();

		th1.start();
		th2.start();
		try {
			sleep(10);
		} catch (InterruptedException e) {
		}
		th1.interrupt();
		th2.interrupt();
	}
}

class Waiter extends Thread {
	
	Thread toWait;
	
	Waiter(Thread t) {
		toWait = t;	
	}

	public void run() {
		Thread t;
		t = toWait;
		try {
			t.join(1000);
		} catch (InterruptedException ex) {
			System.out.println("Waiter interrupted");
			try {
				t.join(1);
			} catch (InterruptedException ey) {
				System.out.println("Waiter interrupted <2>");
			}
			System.out.println("Time-out");
			try {
				t.join(1000);
			} catch (InterruptedException ez) {
				System.out.println("Waiter interrupted <3>");
			}
			
		}
		System.out.println("End");
	}
}

class myTest extends Thread {

	public void run() {
		int tmp;
		tmp = 0;
		while (tmp < 10) {
			System.out.println("Hej");
			tmp++;
			try {
				sleep(20);
			} catch (InterruptedException e) {
			}					
		}
	}
	
	public static void main(String[] args) {
		myTest a;
		Waiter b;
		
		a = new myTest();
		b = new Waiter(a);
		a.start();
		try {
			sleep(10);
		} catch (InterruptedException e) {
		}		
		b.start();
		try {
			sleep(10);
		} catch (InterruptedException e) {
		}		

		b.interrupt();
		try {
			sleep(10);
		} catch (InterruptedException e) {
		}		

	}
}
