class Wait extends Thread {

	int id;
	static Busy O;
	Wait(int n) {
		id = n;
	}
	
	public static void setSystem() {
		Busy tmp;
		tmp = new Busy();
		O = tmp;
	}
	
	public void run() {
		int tmp;
		tmp = id;
		for(int i=0; i<5000; i++) {
			Object o = new Object();
			if (tmp == 1) System.out.print('.');	
			else System.out.print('-');
		}
		if (tmp == 1) 	sayHello();
		else		  	sayBye();
		
	}

	public synchronized void sayBye() {
		Busy tmp;
		tmp = O;
		tmp.getCond();
		System.out.println("Bye");
	}

	public synchronized void sayHello() {
		Busy tmp;
		tmp = O;
		System.out.println("Hello ");	
		tmp.signalCond();
	}
	
	public synchronized void test() {
		Busy tmp;
		System.out.println("Testing lock-Object freed");
		tmp = O;
		tmp.moreTest();
	}
	
	public static void main(String[] args) {
		int tmp;
		Wait myT1;
		Wait myT2;
		int tmp2;
		Wait.setSystem();
		tmp2 = 1;
		myT1 = new Wait(tmp2);
		tmp2++;
		myT2 = new Wait(tmp2);								

		myT1.start();
		myT2.start();

		try {
			sleep(1000);
		} catch (InterruptedException e) {}
		
		myT2.interrupt();	
		try {
			sleep(1000);
		} catch (InterruptedException e) {}

		myT2.test();
	}
}

class Busy {

	public synchronized void getCond() {
		try {
			wait();
		} catch (InterruptedException e) {
			System.out.println("Busy Catch Block!");
		}
	}
	public synchronized void signalCond() {
		notify();
	}

	public synchronized void moreTest() {
		System.out.println("Testing more deeply...");
	}
}
