package se.lth.cs.sven;

public class PeriodicThread extends se.lth.cs.sven.Thread {

	protected long deadline; // Deadline and period in ms
	protected long period;
	protected boolean interruptedFlag;


	public PeriodicThread(long period){
		this.period = period;
		this.deadline = period;
	}

	public PeriodicThread(long period, long deadline){
		this.period = period;
		this.deadline = deadline;
	}
	public void setDeadline(long deadline) {
		this.deadline = deadline;
	}

	public void setPeriod(long period) {
		this.period = period;
	}	

	public void run(){
		native_run(deadline, period);
	}

	protected native void native_run(long deadline, long period);

	public void perform(){
		System.out.println("PeriodicThread: perform()");
	}

	public void interrupt() {
		interruptedFlag = true;
	}
}
