/* ServerSocket.java -- Class for implementing server side sockets
 * Minimal LRJT lib implementation
 */

package java.net;

import java.io.IOException;


public class ServerSocket {

	private int myfd;
	private static final native int createServerSocket(int port);
	private static final native int accept(int sockfd) throws IOException;
	private static final native void close(int sockfd) throws IOException;

	public ServerSocket() throws IOException {
		System.out.println("ServerSocket() not implemented");
	}

	public ServerSocket(int port) throws IOException {
		myfd = createServerSocket(port);
		//System.out.println("ServerSocket(): myfd = "+myfd);
	}

	public ServerSocket(int port, int backlog) throws IOException {
		this(port);
		System.out.println("Warning: parameter backlog ignored");
	}

	public void bind(SocketAddress endpoint) throws IOException {
		bind(endpoint, 50);
	}

	public void bind(SocketAddress endpoint, int backlog)
		throws IOException {
		System.out.println("ServerSocket.bind() not implemented");
	}

	public Socket accept() throws IOException {
		Socket socket = new Socket();
		if (false) {
			IOException e = new IOException();
		}

		try {
			int trafficfd = accept(myfd);
			socket.setFd(trafficfd);
		} catch (IOException e) {
			// try
			//	 {
			socket.close();
			//	 }
			// catch (IOException e2)
			//	 {
			//	   // Ignore.
			//	 }

			throw e;
		}

		return socket;
	}


	public void close() throws IOException {
		close(myfd);
	}

	public String toString() {
		//	  if (! isBound())
		//		return "ServerSocket[unbound]";

		//	  return ("ServerSocket[addr=" + getInetAddress() + ",port="
		//			 + impl.getPort() + ",localport=" + impl.getLocalPort() + "]");
		return "ServerSocket[toString todo]";
	}

}
