package se.lth.control.io;

import java.io.IOException;
import java.io.OutputStream;

public class UnixSocketOutputStream extends OutputStream {

  private UnixSocketImpl impl;

  public UnixSocketOutputStream(UnixSocketImpl impl) {
    this.impl = impl;
  }

  @Override
  public void write(int data) throws IOException {
    impl.write(data);

  }

  @Override
  public void write(byte[] b, int off, int len) throws IOException {
    impl.write(b, off, len);
  }

}

