package se.lth.control.realtime;

import java.util.BitSet;

import se.lth.control.realtime.comedi.Comedi;

public class DigitalOut extends IOChannel {

  public DigitalOut(int index) throws IOChannelException {
    super(index);
  }
   
  public void open() throws IOChannelException {
    Comedi.digitalOutOpen(index);
  }
  public void close() throws IOChannelException {
    Comedi.digitalOutClose(index);
  }

  public void set(boolean value) throws IOChannelException {
    Comedi.digitalOut(index, value);
  }

}
