package se.lth.control.realtime;

import java.util.BitSet;

import se.lth.control.realtime.comedi.Comedi;

public class EncoderIn extends IOChannel {
  
  public EncoderIn(int index) throws IOChannelException {
    super(index);
  }

  protected void open() throws IOChannelException {
     Comedi.encoderInOpen(index);
  }

  protected void close() throws IOChannelException {
    Comedi.encoderInClose(index);
  }
  
  public long get() throws IOChannelException {
    return Comedi.encoderIn(index);
  }
    
}
