package se.lth.control.realtime.comedi;

public class Comedi {
  public static native double analogIn(int channel) throws ComediException;
  public static native void analogOut(int channel, double value) throws ComediException;
  public static native boolean digitalIn(int channel) throws ComediException;
  public static native void digitalOut(int channel, boolean value) throws ComediException;
  public static native long encoderIn(int channel) throws ComediException;

  public static native void analogInOpen(int channel) throws ComediException;
  public static native void analogOutOpen(int channel) throws ComediException;
  public static native void digitalInOpen(int channel) throws ComediException;
  public static native void digitalOutOpen(int channel) throws ComediException;
  public static native void encoderInOpen(int channel) throws ComediException;

  public static native void analogInClose(int channel) throws ComediException;
  public static native void analogOutClose(int channel) throws ComediException;
  public static native void digitalInClose(int channel) throws ComediException;
  public static native void digitalOutClose(int channel) throws ComediException;
  public static native void encoderInClose(int channel) throws ComediException;

  private static native void Init();

  static  {
    System.loadLibrary("se_lth_control_realtime_comedi_Comedi");
    Init();
  }
}
