/* $Id: FixedPriorityError.java,v 1.3 2005/08/15 13:24:44 d02en Exp $      
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime;

/**
 * Error to be thrown when trying to change the priority of a fixed-priority thread.
 * Such threads should implement the (empty) <code>FixedPriority</code> interface.
 * 
 * @see License
 */

public class FixedPriorityError extends RTError {
}
