/* $Id: RTInterrupted.java,v 1.4 2005/08/15 13:24:44 d02en Exp $        
 * 
 * LJRTlib - The Lund Java-based Real-Time Library
 * Copyright (C) 2005 Dept. of Computer Science, Lund University, Sweden
 * 
 * This is free software under the terms of the GNU LGPL; see License.java
 */

package se.lth.cs.realtime;

/**
 * @see License
 * Unchecked <code>Throwable</code> to be thrown instead of
 * <code>InterruptedException</code>.
 */

public class RTInterrupted extends RTError {

  public RTInterrupted() {
    super();
  }

  public RTInterrupted(String error) {
    super(error);
  }

  public RTInterrupted(String error, Throwable cause) {
    super(error, cause);
  }

  public RTInterrupted(Throwable cause) {
    super(cause);
  }
}
