package se.lth.cs.throttlenet;


/**
 * The <code>PacketLossException</code> describes an exception when a packet is 
 * lost .
 * 
 * @author  Patricia Grudziecka
 * @author  Daniel Nyberg
 * @version 0.8, 12/12/03
 * @since   ThrottleNet0.1
 */
 public class PacketLossException extends Exception {
	
	
	/**
	 * Constructs a new exception with null as its detail message.
	 * 
	 */
	public PacketLossException() {
		super();
	}
	
	
	/**
	 * Constructs a new exception with the specified detail message.
	 * 
	 * @param   message			specified detail message
	 */
	public PacketLossException(String message) {
		super(message);
	}
	
}
