package se.lth.cs.util.linux;

public class ImmobileObjectFactory{
	public static native byte[] createByteArray(long address, int length);
	public static native Object createObject(long address, int length);
	
	public static byte[] createByteArray(String modName, String symName, int length) {
		long a = KernelSymbol.findSymbol(modName, symName);
//		System.out.print("createByteArray : ");
//		System.out.print(modName);
//		System.out.print(":");
//		System.out.print(symName);
//		System.out.print(" = ");
//		System.out.println(a);
		if(a != 0) {
			return createByteArray(a, length);
		} else {
			return null;
		}
	}

	public static Object createObject(String modName, String symName, int length) {
		long a = KernelSymbol.findSymbol(modName, symName);
//		System.out.print(modName);
//		System.out.print(":");
//		System.out.print(symName);
//		System.out.print(" = ");
//		System.out.println(a);
		if(a != 0) {
			return createObject(a, length);
		} else {
			return null;
		}
	}
}
