#include <class_indices.h>
#ifdef SE_LTH_CS_UTIL_LINUX_IMMOBILEOBJECTFACTORY_INDEX

#include <gc.h>
#include <javatypes.h>
#if GC_THREAD == GC_THREAD_PTHREAD
#include <pthread.h>
#endif
#include "java_lang_Object.h"

extern GC_REF(LayoutHead,java_lang_Object_Layout);

GC_REF_FUNC_BEGIN(JByteArray,se_lth_cs_util_linux_ImmobileObjectFactory_createByteArray_long_int, JLong address, JInt length)
	GC_REF(JByteArray, obj);
	GC_FUNC_ENTER
{
		GC_PUSH_ROOT(obj);
		{
		/* for testing: allocate an object on the C heap */
		/* really: set the address to param_address and set the
		   objectsize to param_length+sizeof(objecthead etc.) */
			int foo_size = sizeof(ArrayHead) + 4 + length;
#ifdef TESTING
			printf("WARNING: test code, malloc...\n");
			JByteArray *foo_obj = malloc(foo_size);
#else
			JByteArray *foo_obj = (void *) address;
#endif

#if GC_ALGORITHM == GC_ALGORITHM_INCREMENTAL_MS
			/* fwd-pointer points to the object itself.
			   (The rest of the system is fooled to think that
                            the fp is the object's field in the indirection
 			     table */
			foo_obj->gc.fp = foo_obj;
			GC___ASSIGN(obj.ref, &(foo_obj->gc.fp));	
#elif GC_ALGORITHM == GC_ALGORITHM_INCREMENTAL_MS_NONMOVING
			GC___ASSIGN(obj.ref, foo_obj);
#endif

			//foo_obj->tmplate = ImmobileObject_Layout;
			foo_obj->tmplate = VAL_ARRAY_LAYOUT.ref;
			foo_obj->nbrElements=length;
			foo_obj->objectSize=foo_size;
			foo_obj->arraySize=length;
			foo_obj->_JByteA_length=length;
			//*((JInt*) (&foo_obj->arraySize)+4)=length;
		}

		GC_RETURN_REF(obj);
		GC_POP_ROOT(obj);
}
	GC_FUNC_LEAVE
GC_REF_FUNC_END(_ImmobileObject, se_lth_cs_util_linux_ImmobileObjectFactory_createByteArray_long_int)

GC_REF_FUNC_BEGIN(java_lang_Object,se_lth_cs_util_linux_ImmobileObjectFactory_createObject_long_int, JLong address, JInt length)
	GC_REF(java_lang_Object, obj);
	GC_FUNC_ENTER
{
		GC_PUSH_ROOT(obj);
		{
		/* for testing: allocate an object on the C heap */
		/* really: set the address to param_address and set the
		   objectsize to param_length+sizeof(objecthead etc.) */
			int foo_size = sizeof(java_lang_Object) + length;
#ifdef TESTING
			printf("WARNING: test code, malloc...\n");
			java_lang_Object *foo_obj = malloc(foo_size);
#else
			java_lang_Object *foo_obj = (void *) address;
#endif
			/* fwd-pointer points to the object itself.
			   (The rest of the system is fooled to think that
                            the fp is the object's field in the indirection
 			     table */
#if GC_ALGORITHM == GC_ALGORITHM_INCREMENTAL_MS
			foo_obj->gc.fp = foo_obj;
#endif
			/* HERE BE DRAGONS! 
				How to find a tmplate-pointer?
			*/
			foo_obj->tmplate = java_lang_Object_Layout.ref;
#if GC_ALGORITHM == GC_ALGORITHM_INCREMENTAL_MS
			GC___ASSIGN(obj.ref, &(foo_obj->gc.fp));	
#elif GC_ALGORITHM == GC_ALGORITHM_INCREMENTAL_MS_NONMOVING
			GC___ASSIGN(obj.ref, foo_obj);
#endif
		}

		GC_RETURN_REF(obj);
		GC_POP_ROOT(obj);
}
	GC_FUNC_LEAVE
GC_REF_FUNC_END(java_lang_Object, se_lth_cs_util_linux_ImmobileObjectFactory_createObject_int_int)

#endif
