#include <class_indices.h>

#ifdef JAVA_LANG_MATH_INDEX

#include <javatypes.h>
#include <math.h>

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_sin_double, JDouble x)
GC_FUNC_ENTER;
return sin(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_sin_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_cos_double, JDouble x)
GC_FUNC_ENTER;
return cos(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_cos_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_tan_double, JDouble x)
GC_FUNC_ENTER;
return tan(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_tan_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_asin_double, JDouble x)
GC_FUNC_ENTER;
return asin(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_asin_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_acos_double, JDouble x)
GC_FUNC_ENTER;
return acos(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_acos_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_atan_double, JDouble x)
GC_FUNC_ENTER;
return atan(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_atan_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_atan2_double_double, JDouble x, JDouble y)
GC_FUNC_ENTER;
return atan2(x, y);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_atan2_double_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_exp_double, JDouble x)
GC_FUNC_ENTER;
return exp(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_exp_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_log_double, JDouble x)
GC_FUNC_ENTER;
return log(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_log_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_sqrt_double, JDouble x)
GC_FUNC_ENTER;
return sqrt(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_sqrt_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_pow_double_double, JDouble x, JDouble y)
GC_FUNC_ENTER;
return pow(x, y);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_pow_double_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_IEEEremainder_double_double, JDouble x, JDouble y)
GC_FUNC_ENTER;
return remainder(x, y);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_IEEEremainder_double_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_ceil_double, JDouble x)
GC_FUNC_ENTER;
return ceil(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_ceil_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_floor_double, JDouble x)
GC_FUNC_ENTER;
return floor(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_floor_double)

GC_VAR_FUNC_BEGIN(JDouble, java_lang_Math_rint_double, JDouble x)
GC_FUNC_ENTER;
return rint(x);
GC_FUNC_LEAVE;
GC_VAR_FUNC_END(JDouble, java_lang_Math_rint_double)

#endif
