#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>

//#include <sys/types.h>
//#include <netinet/in.h>
//#include <sys/socket.h>
//#include <arpa/inet.h>
//#include <netinet/tcp.h>
//#include <netdb.h>
#include <fcntl.h>


GC_PROC_BEGIN(java_io_OutputStream_writeFD_long_byteA_int,GC_PARAM(java_lang_Object,this), JLong fd, GC_PARAM(JByteArray, data), JInt len)
  GC_PARAM_REF(java_lang_Object,this);
  GC_PARAM_REF(JByteArray, data);
  GC_PUSH_PARAM(this);
  GC_PUSH_PARAM(data);
  GC_FUNC_ENTER
  {
  	//HERE BE DRAGONS data->ref should be data.ref but that doesn't work
	gc_lock();
  	write((int)fd, GC___PTR(data->ref)->data, (int)len);
	gc_unlock();
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(data);
  GC_POP_PARAM(this);
GC_PROC_END(java_io_OutputStream_writeFD)

GC_PROC_BEGIN(java_io_SimpleTCPOutputStream_close_long,GC_PARAM(java_lang_Object,this), JLong fd)
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
  {
	close(fd);
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_io_SimpleTCPOutputStream_close_long)
