/* $Revision: 1.1.2.3 $
 * $Author: andersn $
 * $Date: 2005/04/15 12:54:18 $
 */
#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>
#include <sys/mman.h>
#include <java_lang_Object.h>
#include <java_lang_Thread.h>
#include <class_indices.h>
#include <errno.h>
#include <string.h>


#define NS_MS 	1000000
#define MS 		1000
#define NSEC 1000000000

GC_VAR_FUNC_BEGIN(JInt,java_lang_Object_hashCode,GC_PARAM(java_lang_Object,this)) EXCEPTION_THROWS;
{
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
  {
    JInt _result_;
    _result_ = (JInt)this->ref;
    GC_RETURN_VAR(_result_);
  }

  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
}
GC_VAR_FUNC_END(JInt,java_lang_Object_hashCode)


#if 0
GC_PROC_BEGIN(java_lang_Object_wait,GC_PARAM(java_lang_Object,this)) EXCEPTION_THROWS;
{
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;  
	printf("java_lang_object.wait() not implemented\n");
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
}
GC_PROC_END(java_lang_Object_wait)

GC_PROC_BEGIN(java_lang_Object_wait_long,GC_PARAM(java_lang_Object,this),JLong timeout) EXCEPTION_THROWS;
{
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
	printf("java_lang_object.wait(long) not implemented\n");
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
}
GC_PROC_END(java_lang_Object_wait_long)
#endif
GC_PROC_BEGIN(java_lang_Object_wait_long_int,GC_PARAM(java_lang_Object,this),JLong timeout,JInt nanos) EXCEPTION_THROWS
{
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
	printf("java_lang_object.wait(long,int) not implemented\n");
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
}
GC_PROC_END(java_lang_Object_wait_long_int)

GC_PROC_BEGIN(java_lang_Object_notify,GC_PARAM(java_lang_Object,this))
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
  {
	printf("java_lang_object.notify() not implemented\n");
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Object_notify)

GC_PROC_BEGIN(java_lang_Object_notifyAll,GC_PARAM(java_lang_Object,this))
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
  {
	printf("java_lang_object.notifyAll() not implemented\n");
  }
  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_Object_notifyAll)
