/* $Revision: 1.5.2.7 $
 * $Author: andersn $
 * $Date: 2004/07/01 09:49:27 $
 */
#include <pthread.h>
#include <sys/time.h>
#include <gc.h>
#include <gci_common.h>
#include <exception.h>
#include <javatypes.h>
#include <sys/mman.h>
#include <java_lang_Object.h>
#include <java_lang_Thread.h>
#include <class_indices.h>
#include <errno.h>
#include <string.h>
#include <java2c_lxrt.h>
 
#ifndef JAVA_LANG_NOTIMPLEMENTEDEXCEPTION_INDEX
#define  JAVA_LANG_NOTIMPLEMENTEDEXCEPTION_INDEX -1
#endif


//FIXME: Moving GC breaks hashCode contract? (result not time constant) 
GC_VAR_FUNC_BEGIN(JInt,java_lang_Object_hashCode,
		  GC_PARAM(java_lang_Object,this)) EXCEPTION_THROWS;
{
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
  {
    JInt _result_;
    _result_ = (JInt)this->ref;
    GC_RETURN_VAR(_result_);
  }

  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
}
GC_VAR_FUNC_END(JInt,java_lang_Object_hashCode)


GC_REF_FUNC_BEGIN(java_lang_Object,java_lang_Object_clone,
		  GC_PARAM(java_lang_Object,this)) EXCEPTION_THROWS;
{
  GC_PARAM_REF(java_lang_Object,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER;
  {
    //FIXME: Here be dragons. LACK IMPLEMENTATION
    GC_REF(java_lang_Object,result);
    GC_PUSH_ALIAS(result);
/*     EXCEPTION_THROW(0, JAVA_LANG_NOTIMPLEMENTEDEXCEPTION_INDEX) */
    
    GC_ASSIGN(result,this);
    GC_RETURN_REF(result);
  }

  GC_FUNC_LEAVE;
  GC_POP_PARAM(this);
}
GC_REF_FUNC_END(java_lang_Object,java_lang_Object_clone)


