/* $Revision: 1.3.2.9 $
 * $Author: andersn $
 * $Date: 2005/04/22 12:16:17 $
 */

#include <class_indices.h>
#ifdef JAVA_LANG_STRING_INDEX

#include <pthread.h>
#include <javatypes.h>
#include <sys/time.h>
#include <stddef.h>
#include <gc.h>
#include <stdio.h>
#include <java_lang_String.h>
#include <java_lang_Object.h>

// Special constructor with no Java counterpart
// used in the special case:
// new String("string literal")
GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_String_CCharArray, void* class, GC_PARAM(LayoutHead,layout),char* value)
  GC_PARAM_REF(LayoutHead,layout);
  GC_PUSH_PARAM(layout);
  GC_FUNC_ENTER
  GC_REF(java_lang_String,this);
  GC_PUSH_ROOT(this);
  {
    GC_REF(JCharArray, data);
    GC_PUSH_ROOT(data);
    GC_NEW(this,layout);
    GC_SET(this,class,class);
    
    GC_REF_FUNC_CALL(data,newJCharArray,strlen(value)+1);
    strcpy((char*) &GC___PTR(data->ref)->data[0],value);
    
    GC_SET_REF(this,_java_lang_String_value,data);
    GC_SET(this,_java_lang_String_count,strlen(value));
    GC_SET(this,_java_lang_String_offset,0);

    GC_POP_ROOT(data);
    GC_RETURN_REF(this);
  }
  GC_POP_ROOT(this);
  GC_FUNC_LEAVE;
  GC_POP_PARAM(layout);
GC_REF_FUNC_END(java_lang_String ,java_lang_String_String_CCharArray)


/* Deprecated? */
GC_PROC_BEGIN(java_lang_String_init_charA_int_int_boolean,GC_PARAM(java_lang_String,this),GC_PARAM(JCharArray,chars),JInt offset,JInt count,JBoolean dont_copy) 
  GC_PARAM_REF(java_lang_String,this);
  GC_PARAM_REF(JCharArray,chars);
  GC_PUSH_PARAM(this);
  GC_PUSH_PARAM(chars);
  GC_FUNC_ENTER
{  
  GC_REF(JCharArray, data);
  GC_PUSH_ROOT(data);
  GC_REF_FUNC_CALL(data,newJCharArray,count);

  memcpy((char*) &GC___PTR(data->ref)->data[0],
	 (char*) &GC___PTR(chars->ref)->data[offset],
	 count);

  GC_SET_REF(this,_java_lang_String_value,data);
  GC_POP_ROOT(data);
  
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(chars);
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_String_init_charA_int_int_boolean)

GC_PROC_BEGIN(java_lang_String_init_byteA_int_int_java_lang_String,GC_PARAM(java_lang_String,this),GC_PARAM(JByteArray,chars),JInt offset,JInt count,GC_PARAM(java_lang_String,enc)) 
  GC_FUNC_ENTER
// Lacks implementation!!

  GC_FUNC_LEAVE
GC_PROC_END(java_lang_String_init_byteA_int_int_java_lang_String)

GC_PROC_BEGIN(java_lang_String_init,GC_PARAM(java_lang_String,this)) 
  GC_PARAM_REF(java_lang_String,this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
{
  GC_REF(JCharArray, data);
  GC_PUSH_ROOT(data);
  GC_REF_FUNC_CALL(data,newJCharArray,0);
  GC_SET_REF(this,_java_lang_String_value,data);
  GC_POP_ROOT(data);
  
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(this);
GC_PROC_END(java_lang_String_init)

GC_PROC_BEGIN(java_lang_String_init_byteA_int_int_int,GC_PARAM(java_lang_String,this),GC_PARAM(JByteArray,chars),JInt hibyte, JInt offset,JInt count) 
  GC_FUNC_ENTER
// Lacks implementation!!

  GC_FUNC_LEAVE
GC_PROC_END(java_lang_String_init_byteA_int_int_int)

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_valueOf_charA_int_int,GC_PARAM(java_lang_String,this), JInt offset, JInt count) */
/*   GC_PARAM_REF(java_lang_String,this); */
/*   GC_PUSH_PARAM(this); */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_REF(this); */
/*    GC_FUNC_LEAVE */
/*   GC_POP_PARAM(this); */
/* GC_REF_FUNC_END(java_lang_String,java_lang_String_valueOf_charA_int_int) */

/* GC_VAR_FUNC_BEGIN(JInt,java_lang_String_hashCode,GC_PARAM(java_lang_String,this)) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JInt,java_lang_String_hashCode) */

/* GC_VAR_FUNC_BEGIN(JBoolean,java_lang_String_equals_java_lang_Object,GC_PARAM(java_lang_String,this),GC_PARAM(java_lang_Object,obj)) */
/*   GC_PARAM_REF(java_lang_String,this); */
/*   GC_PARAM_REF(java_lang_String,obj); */
/*   GC_PUSH_PARAM(this); */
/*   GC_PUSH_PARAM(obj); */
/*    GC_FUNC_ENTER */
/* {   */
/*   GC_REF(JCharArray, data_this); */
/*   GC_REF(JCharArray, data_obj); */
/*   struct java_lang_String_ClassStruct *thisClass; */
/*   struct java_lang_String_ClassStruct *objClass; */
/*   int thisLen, objLen; */
/*   GC_PUSH_ROOT(data_this); */
/*   GC_PUSH_ROOT(data_obj); */


/*   GC_GET(thisClass,this,class); */
/*   GC_GET(objClass,obj,class); */

/*   if (thisClass != objClass) { */
/*     // If obj is not a String, there's no meaning in continuing */
/* /\*     printf("String.equals() Not the same class\n"); *\/ */
/*     GC_RETURN_VAR(false); */
/*   } */

/*   GC_GET_REF(data_this,this,_java_lang_String_value); */
/*   GC_GET_REF(data_obj,obj,_java_lang_String_value); */
/*   GC_GET(thisLen,this,_java_lang_String_count); */
/*   GC_GET(objLen,obj,_java_lang_String_count); */


/*   if (thisLen != objLen) { */
/*     // Different length, can't be equal */
/* /\*     printf("String.equals() Not the same length: %d != %d\n",thisLen,objLen); *\/ */
/*     GC_RETURN_VAR(false); */
/*   } */

/*   { */
/*     int result, i; */
/*     result = strncmp(&GC___PTR(data_this->ref)->data[0],&GC___PTR(data_obj->ref)->data[0],thisLen); */
/*     if (result == 0) { */
/*       GC_RETURN_VAR(true); */
/*     } */
/*   } */


/*   GC_POP_ROOT(data_obj); */
/*   GC_POP_ROOT(data_this); */
  
/*   // Oh well, they weren't equal it seems. */
/*   printf("String.equals() Not the same content\n"); */

/*   GC_RETURN_VAR(false); */

/* } */
/*    GC_FUNC_LEAVE */
/*   GC_POP_PARAM(obj); */
/*   GC_POP_PARAM(this); */
/* GC_VAR_FUNC_END(JBoolean,java_lang_String_equals_java_lang_Object) */

/* GC_VAR_FUNC_BEGIN(JChar,java_lang_String_charAt_int,GC_PARAM(java_lang_String,this),JInt index) */
/* GC_PARAM_REF(java_lang_String,this); */
/* GC_PUSH_PARAM(this); */
/* GC_FUNC_ENTER */
/*   JChar c; */
/*   GC_REF(JCharArray, data); */
/*   GC_PUSH_ROOT(data); */
/*   GC_GET_REF(data,this,_java_lang_String_value); */
/*   c = GC___PTR(data->ref)->data[index].bytes; */
/*   GC_POP_ROOT(data); */
/*   GC_RETURN_VAR(c); */
/* GC_FUNC_LEAVE; */
/* GC_POP_PARAM(this); */
/* GC_VAR_FUNC_END(JChar,java_lang_String_charAt_int) */

/* GC_PROC_BEGIN(java_lang_String_getChars_int_int_charA_int,GC_PARAM(java_lang_String,this),JInt srcBegin,JInt srcEnd,GC_PARAM(JCharArray,dst),JInt dstBegin)  */
/*   GC_FUNC_ENTER */
/* // Lacks implementation!! */

/*   GC_FUNC_LEAVE */
/* GC_PROC_END(java_lang_String_getChars_int_int_charA_int) */

/* GC_REF_FUNC_BEGIN(JByteArray,java_lang_String_getBytes_java_lang_String,GC_PARAM(java_lang_String,this),GC_PARAM(java_lang_String,enc)) */
/*   GC_PARAM_REF(java_lang_String,this); */
/*   GC_PARAM_REF(java_lang_String,enc); */
/*   GC_PUSH_PARAM(this); */
/*   GC_PUSH_PARAM(enc); */
/*   GC_FUNC_ENTER */
/*   GC_REF(JByteArray, data); */

/*   { */
/*     GC_REF(JCharArray, thisData); */
/*     JInt thisLength; */
/*     GC_PUSH_ROOT(data); */
/*     GC_PUSH_ROOT(thisData); */
    
/*     GC_GET_REF(thisData,this,_java_lang_String_value); */
/*     GC_GET(thisLength,thisData,_JCharA_length); */



/*     GC_REF_FUNC_CALL(data,newJByteArray,thisLength); */
/*     strcpy(&GC___PTR(data->ref)->data[0],&GC___PTR(thisData->ref)->data[0]); */
    

/*     GC_POP_ROOT(thisData); */
/*     GC_RETURN_REF(data); */
/*     GC_POP_ROOT(data);  */
/*   } */

/*    GC_FUNC_LEAVE */
/*   GC_POP_PARAM(enc); */
/*   GC_POP_PARAM(this); */
/* GC_REF_FUNC_END(JByteArray,java_lang_String_getBytes_java_lang_String) */

/* GC_PROC_BEGIN(java_lang_String_getBytes_int_int_byteA_int,GC_PARAM(java_lang_String,this),JInt srcBegin,JInt srcEnd,GC_PARAM(JByteArray,dst),JInt dstBegin) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */

/*    GC_FUNC_LEAVE */
/* GC_PROC_END(java_lang_String_getBytes_int_int_byteA_int) */

/* GC_REF_FUNC_BEGIN(JCharArray,java_lang_String_toCharArray,GC_PARAM(java_lang_String,this)) */
/*   GC_PARAM_REF(java_lang_String,this); */
/*   GC_PUSH_PARAM(this); */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_REF(this); */
/*    GC_FUNC_LEAVE */
/*   GC_POP_PARAM(this); */
/* GC_REF_FUNC_END(JCharArray,java_lang_String_toCharArray) */

/* GC_VAR_FUNC_BEGIN(JBoolean,java_lang_String_equalsIgnoreCase_java_lang_String,GC_PARAM(java_lang_String,this),GC_PARAM(java_lang_String,anotherString)) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JBoolean,java_lang_String_equals_IgnoreCase_java_lang_String) */

/* GC_VAR_FUNC_BEGIN(JInt,java_lang_String_compareTo_java_lang_String,GC_PARAM(java_lang_String,this),GC_PARAM(java_lang_String,anotherString)) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JInt,java_lang_String_compareTo_java_lang_String) */

/* GC_VAR_FUNC_BEGIN(JBoolean,java_lang_String_regionMatches_int_java_lang_String_int_int,GC_PARAM(java_lang_String,this),JInt toffset,GC_PARAM(java_lang_String,other),JInt ooffset,JInt len) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JBoolean,java_lang_String_regionMatches_int_java_lang_String_int_int) */

/* GC_VAR_FUNC_BEGIN(JBoolean,java_lang_String_regionMatches_boolean_int_java_lang_String_int_int,GC_PARAM(java_lang_String,this),JBoolean ignoreCase,JInt toffset,GC_PARAM(java_lang_String,other),JInt ooffset,JInt len) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JBoolean,java_lang_String_regionMatches_boolean_int_java_lang_String_int_int) */

/* GC_VAR_FUNC_BEGIN(JBoolean,java_lang_String_startsWith_java_lang_String_int,GC_PARAM(java_lang_String,this),GC_PARAM(java_lang_String,prefix),JInt toffset) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JBoolean,java_lang_String_startsWith_java_lang_String_int) */

/* GC_VAR_FUNC_BEGIN(JInt,java_lang_String_indexOf_int_int,GC_PARAM(java_lang_String,this),JInt ch,JInt fromIndex) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JInt,java_lang_String_indexOf_int_int) */

/* GC_VAR_FUNC_BEGIN(JInt,java_lang_String_indexOf_java_lang_String_int,GC_PARAM(java_lang_String,this),GC_PARAM(java_lang_String,str),JInt fromIndex) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JInt,java_lang_String_indexOf_java_lang_String_int) */

/* GC_VAR_FUNC_BEGIN(JInt,java_lang_String_lastIndexOf_int_int,GC_PARAM(java_lang_String,this),JInt ch,JInt fromIndex) */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_VAR(0); */
/*    GC_FUNC_LEAVE */
/* GC_VAR_FUNC_END(JInt,java_lang_String_lastIndexOf_int_int) */

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_substring_int_int,GC_PARAM(java_lang_String,this),JInt beginIndex, JInt endIndex) */
/*   GC_PARAM_REF(java_lang_String,this); */
/*   GC_PUSH_PARAM(this); */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_REF(this); */
/*    GC_FUNC_LEAVE */
/*   GC_POP_PARAM(this); */
/* GC_REF_FUNC_END(java_lang_String,java_lang_String_substring_int_int) */

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_concat_java_lang_String,GC_PARAM(java_lang_String,this),GC_PARAM(java_lang_String,str)) */
/*   GC_PARAM_REF(java_lang_String,this); */
/*   GC_PARAM_REF(java_lang_String,str); */
/*   GC_PUSH_PARAM(this); */
/*   GC_PUSH_PARAM(str); */
/*   GC_FUNC_ENTER; */
/* { */
/*   JInt thisLength,strLength;   */
/*   GC_REF(JCharArray, newData); */
/*   GC_REF(JCharArray, thisData); */
/*   GC_REF(JCharArray, strData); */
/*   GC_PUSH_ROOT(newData); */
/*   GC_PUSH_ROOT(thisData); */
/*   GC_PUSH_ROOT(strData); */

/*   GC_GET_REF(thisData,this,_java_lang_String_value); */
/*   GC_GET_REF(strData,str,_java_lang_String_value); */
/* /\*   GC_GET(thisLength,thisData,_JCharA_length); *\/ */
/* /\*   GC_GET(strLength,strData,_JCharA_length); *\/ */
/*   GC_GET(thisLength,this,_java_lang_String_count); */
/*   GC_GET(strLength,str,_java_lang_String_count); */
/* /\*   GC_VAR_FUNC_CALL(thisLength,java_lang_String_length,GC_PASS(this)); *\/ */
/* /\*   GC_VAR_FUNC_CALL(strLength,java_lang_String_length,GC_PASS(str)); *\/ */

/*   GC_REF_FUNC_CALL(newData,newJCharArray,thisLength+strLength); */

/*   memcpy((char*) &GC___PTR(newData->ref)->data[0], */
/* 	 (char*) &GC___PTR(thisData->ref)->data[0], */
/* 	 thisLength); */
/*   memcpy((char*) &GC___PTR(newData->ref)->data[thisLength], */
/* 	 (char*) &GC___PTR(strData->ref)->data[0], */
/* 	 strLength); */

/*   GC_SET_REF(this,_java_lang_String_value,newData); */
/*   GC_SET(this,_java_lang_String_count,thisLength+strLength); */

/*   GC_POP_ROOT(strData); */
/*   GC_POP_ROOT(thisData); */
/*   GC_POP_ROOT(newData); */
   

/*    GC_RETURN_REF(this); */
/* } */
/*    GC_FUNC_LEAVE */
/*   GC_POP_PARAM(str); */
/*   GC_POP_PARAM(this); */
/* GC_REF_FUNC_END(java_lang_String,java_lang_String_concat_java_lang_String) */

GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_replace_char_char,GC_PARAM(java_lang_String,this),JChar oldChar, JChar newChar)
  GC_PARAM_REF(java_lang_String,this);
  GC_PUSH_PARAM(this);
   GC_FUNC_ENTER
// Lacks implementation!!
   GC_RETURN_REF(this);
   GC_FUNC_LEAVE
  GC_POP_PARAM(this);
GC_REF_FUNC_END(java_lang_String,java_lang_String_replace_char_char)

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_trim,GC_PARAM(java_lang_String,this)) */
/*   GC_PARAM_REF(java_lang_String,this); */
/*   GC_PUSH_PARAM(this); */
/*    GC_FUNC_ENTER */
/* // Lacks implementation!! */
/*    GC_RETURN_REF(this); */
/*    GC_FUNC_LEAVE */
/*   GC_POP_PARAM(this); */
/* GC_REF_FUNC_END(java_lang_String,java_lang_String_trim) */

GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_intern,GC_PARAM(java_lang_String,this))
  GC_PARAM_REF(java_lang_String,this);
  GC_PUSH_PARAM(this);
   GC_FUNC_ENTER
// Lacks implementation!!
   GC_RETURN_REF(this);
   GC_FUNC_LEAVE
  GC_POP_PARAM(this);
GC_REF_FUNC_END(java_lang_String,java_lang_String_intern)

     extern GC__IMPL_REF_DECL(LayoutHead,java_lang_String_Layout) *java_lang_String_Layout;
     extern struct java_lang_String_ClassStruct java_lang_String_Class;

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_valueOf_int,JInt i) */
/*   GC_FUNC_ENTER */
/*   GC_REF(java_lang_String,s); */
/*   GC_PUSH_ROOT(s); */
/*   { */
/*     char value[10]; */
/*     GC_REF(JCharArray, data); */
/*     GC_PUSH_ROOT(data); */
/*     GC_NEW(s,java_lang_String_Layout); */
/*     GC_SET(s,class,&java_lang_String_Class); */
    
/* /\*     itoa(i, value, 10); *\/ */
/*     sprintf(value,"%d",i); */
/*     GC_REF_FUNC_CALL(data,newJCharArray,strlen(value)+1); */
/*     strcpy((char*) &GC___PTR(data->ref)->data[0],value); */

/*     GC_SET_REF(s,_java_lang_String_value,data); */
/*     GC_SET(s,_java_lang_String_count,strlen(value)); */

/*     GC_POP_ROOT(data); */
/*     GC_RETURN_REF(s); */
/*   } */
/*   GC_POP_ROOT(s); */
/*   GC_FUNC_LEAVE; */
/* GC_REF_FUNC_END(java_lang_String ,java_lang_String_valueOf_int) */

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_valueOf_long,JLong i) */
/*   GC_FUNC_ENTER */
/*   GC_REF(java_lang_String,s); */
/*   GC_PUSH_ROOT(s); */
/*   { */
/*     char value[20]; */
/*     GC_REF(JCharArray, data); */
/*     GC_PUSH_ROOT(data); */
/*     GC_NEW(s,java_lang_String_Layout); */
/*     GC_SET(s,class,&java_lang_String_Class); */
/*     sprintf(value,"%lld",i); */
/*     GC_REF_FUNC_CALL(data,newJCharArray,strlen(value)+1); */
/*     strcpy((char*) &GC___PTR(data->ref)->data[0],value); */

/*     GC_SET_REF(s,_java_lang_String_value,data); */
/*     GC_SET(s,_java_lang_String_count,strlen(value)); */

/*     GC_POP_ROOT(data); */
/*     GC_RETURN_REF(s); */
/*   } */
/*   GC_POP_ROOT(s); */
/*   GC_FUNC_LEAVE; */
/* GC_REF_FUNC_END(java_lang_String ,java_lang_String_valueOf_long) */

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_valueOf_float,JFloat i) */
/*   GC_FUNC_ENTER */
/*   GC_REF(java_lang_String,s); */
/*   GC_PUSH_ROOT(s); */
/*   { */
/*     char value[20]; */
/*     GC_REF(JCharArray, data); */
/*     GC_PUSH_ROOT(data); */
/*     GC_NEW(s,java_lang_String_Layout); */
/*     GC_SET(s,class,&java_lang_String_Class); */
/*     sprintf(value,"%g",i); */
/*     GC_REF_FUNC_CALL(data,newJCharArray,strlen(value)+1); */
/*     strcpy((char*) &GC___PTR(data->ref)->data[0],value); */

/*     GC_SET_REF(s,_java_lang_String_value,data); */
/*     GC_SET(s,_java_lang_String_count,strlen(value)); */

/*     GC_POP_ROOT(data); */
/*     GC_RETURN_REF(s); */
/*   } */
/*   GC_POP_ROOT(s); */
/*   GC_FUNC_LEAVE; */
/* GC_REF_FUNC_END(java_lang_String ,java_lang_String_valueOf_float) */

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_valueOf_double,JDouble i) */
/*   GC_FUNC_ENTER */
/*   GC_REF(java_lang_String,s); */
/*   GC_PUSH_ROOT(s); */
/*   { */
/*     char value[20]; */
/*     GC_REF(JCharArray, data); */
/*     GC_PUSH_ROOT(data); */
/*     GC_NEW(s,java_lang_String_Layout); */
/*     GC_SET(s,class,&java_lang_String_Class); */
/*     sprintf(value,"%.16g",i); */
/*     GC_REF_FUNC_CALL(data,newJCharArray,strlen(value)+1); */
/*     strcpy((char*) &GC___PTR(data->ref)->data[0],value); */

/*     GC_SET_REF(s,_java_lang_String_value,data); */
/*     GC_SET(s,_java_lang_String_count,strlen(value)); */

/*     GC_POP_ROOT(data); */
/*     GC_RETURN_REF(s); */
/*   } */
/*   GC_POP_ROOT(s); */
/*   GC_FUNC_LEAVE; */
/* GC_REF_FUNC_END(java_lang_String ,java_lang_String_valueOf_double) */

/* GC_REF_FUNC_BEGIN(java_lang_String,java_lang_String_valueOf_char,JChar i) */
/*   GC_FUNC_ENTER */
/*   GC_REF(java_lang_String,s); */
/*   GC_PUSH_ROOT(s); */
/*   { */
/*     char value[20]; */
/*     GC_REF(JCharArray, data); */
/*     GC_PUSH_ROOT(data); */
/*     GC_NEW(s,java_lang_String_Layout); */
/*     GC_SET(s,class,&java_lang_String_Class); */
/*     sprintf(value,"%c",i); */
/*     GC_REF_FUNC_CALL(data,newJCharArray,strlen(value)+1); */
/*     strcpy((char*) &GC___PTR(data->ref)->data[0],value); */

/*     GC_SET_REF(s,_java_lang_String_value,data); */
/*     GC_SET(s,_java_lang_String_count,strlen(value)); */

/*     GC_POP_ROOT(data); */
/*     GC_RETURN_REF(s); */
/*   } */
/*   GC_POP_ROOT(s); */
/*   GC_FUNC_LEAVE; */
/* GC_REF_FUNC_END(java_lang_String ,java_lang_String_valueOf_char) */

#endif
