
#include <rtai_sched.h>
#include <kernel.h>

#include <javatypes.h>

#include <aux.h>

void monitor_init(java_lang_Object *this){
	if(this != 0 && this->lock == 0) {
		this->lock = kmalloc(sizeof(SEM),0);
		rt_typed_sem_init(this->lock,1,RES_SEM);
	}
}

void monitor_enter(java_lang_Object *this){
	rt_sem_wait(this->lock);
}

void monitor_leave(java_lang_Object *this){
	rt_sem_signal(this->lock);
}

/* Function translates Java priority in an equivalent scheduler's priority
   specified by the parameter sched */

int javaPr2schedPr(int java_prio,int sched) {
//        return (10-java_prio)*((RT_LOWEST_PRIORITY-4000)/9) + 2000;
	return 110-java_prio;
}

int schedPr2javaPr(int sched_prio,int sched) {
//        return 10-sched_prio*9/(RT_LOWEST_PRIORITY - 2000);
	return 110-sched_prio;
}

