/* $Revision: 1.1.2.2 $
 * $Author: andersn $
 * $Date: 2004/03/06 10:46:14 $
 */
#include <javatypes.h>
//#include <sys/time.h>
#include <stddef.h>
#include <gc.h>
/* #define INT_MAX 32767 */
/* #include <stdio.h> */
//#include <pthread.h>
#include <java_lang_String.h>

#include <linux/kernel.h>

#if GC_THREAD == GC_THREAD_RTAIKERNEL

#include <linux/module.h>
//#include <linux/kernel.h>
#include <linux/version.h>
//#include <linux/vmalloc.h>
//#include <linux/errno.h>
#include <rtai.h>
#include <rtai_sched.h>
#include "rtai_fifos.h"
#include <rtai_types.h>

#endif  // GC_THREAD

GC_PROC_BEGIN(RTSystem_sleepUntil_long,JLong micros)
  GC_FUNC_ENTER
  {

    rt_sleep_until(nano2count(micros*1000));

  }
  GC_FUNC_LEAVE
GC_PROC_END(RTSystem_sleepUntil_long)


GC_VAR_FUNC_BEGIN(JLong,RTSystem_currentTimeMillis)
  GC_FUNC_ENTER;
  {
    JLong time;
#ifndef HOST_RTAI_KERNEL
    time = rt_get_time_ns() / (JLong) 1E6;
#else
    // HERE BE DRAGONS! hack to avoid undefined __divdi3
/*     time = rt_get_time_ns() >> 20 ; */
    time = rt_get_time_ns() / 1E6;
#endif
    GC_RETURN_VAR(time);
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,RTSystem_currentTimeMillis)

GC_VAR_FUNC_BEGIN(JLong,RTSystem_currentTimeMicros)
  GC_FUNC_ENTER;
  {
    JLong time;
#ifndef HOST_RTAI_KERNEL
    time = rt_get_time_ns() / (JLong) 1E3;
#else
    // HERE BE DRAGONS! hack to avoid undefined __divdi3
/*     time = rt_get_time_ns() >> 20 ; */
    time = rt_get_time_ns() / 1E3;
#endif
    GC_RETURN_VAR(time);
 }
 GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,RTSystem_currentTimeMicros)

