#ifndef THREAD_H_ONCE
#define THREAD_H_ONCE
#include <javatypes.h>
#include <gc.h>

struct _Thread_ClassStruct {
  /* Super class struct pointer */
  struct _Thread_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
};

typedef GC_STRUCT_BEGIN(_Thread)
  GC_STRUCT_VAR(struct _Thread_ClassStruct *,class);
  GC_STRUCT_VAR(JLong,target);
GC_STRUCT_END(_Thread) _Thread;

struct java_lang_Object_ClassStruct {
  /* Super class struct pointer */
  struct java_lang_Object_MethodTblStruct *methodTbl;
  /* static fields go here, from this class and its ancestors */
};

typedef GC_STRUCT_BEGIN(java_lang_Object)
  GC_STRUCT_VAR(struct java_lang_Object_ClassStruct *,class);
GC_STRUCT_END(java_lang_Object) java_lang_Object;

struct _Thread_MethodTblStruct {
  /* Method pointers, static and non-static */
  void (*finalize)(REF(struct java_lang_Object));
  void (*sleep_long)(JLong);
  void (*start)(REF(struct _Thread));
  void (*run)(REF(struct _Thread));
};

struct java_lang_Object_MethodTblStruct {
  /* Method pointers, static and non-static */
  void (*finalize)(REF(struct java_lang_Object));
} ;

#endif
