#ifndef SEMAPHORE_H
#define SEMAPHORE_H

#include "AVR_Kernel.h"
#include "AVR_Queue.h"

semaphore_t* new_semaphore(int initial);
mutex_t* new_mutex();
void mutex_register_thread(kthread_t*, mutex_t*);

void semaphore_take(semaphore_t*);
void semaphore_give(semaphore_t*);
void mutex_take(mutex_t*);
void mutex_give(mutex_t*);

#endif
