#ifndef SEMAPHORE_H
#define SEMAPHORE_H

#include "AVR_Kernel.h"
#include "AVR_Queue.h"

Semaphore *allocSemaphore(int this, int initialValue);
Mutex *allocMutex(int this);
void registerThread(int this, KernelThread *thread, Mutex *mutex);

void takeBinarySemaphore(int this, Semaphore *s);
void giveBinarySemaphore(int this, Semaphore *s);
void takeCountingSemaphore(int this, Semaphore *s);
void giveCountingSemaphore(int this, Semaphore *s);
void takeMutex(int this, Mutex *m);
void giveMutex(int this, Mutex *m);

#endif
