/* $Revision: 1.5.2.4 $
 * $Author: andersn $
 * $Date: 2005/01/31 12:32:29 $
 */

#include <javatypes.h>
/* #include <sys/time.h> */
/* #include <stddef.h> */
#include <gc.h>
/* #include <stdio.h> */
#include <AVR_Kernel.h>
#include <AVR_Semaphore.h>
#include <java_lang_String.h>

Semaphore* printMutex;
/* extern JLong tickCounter; */

void initPrintMutex(void) {
  printMutex = allocSemaphore(0,1);
}

void transmit(char cc) {
/*   while (!(inp(UCSR0A) & (1<<UDRE))) ; */
/*   outp(cc,UDR0);   */
  while (!(UCSR0A & (1<<UDRE))) ;
  UDR0 = cc;  
}

void transmitInt(unsigned int i) {
  char cc[6];
  int ix=0;
  if (i==0) {
    transmit('0');
  } else {
    while (i>0) {
      cc[ix++] = (i % 10)+0x30;
      i /= 10;
    }
    while (ix > 0) {
/*       while (!(inp(UCSR0A) & (1<<UDRE))) ; */
      while (!(UCSR0A & (1<<UDRE))) ;
/*       outp(cc[--ix],UDR0);   */
      UDR0 = cc[--ix];
    }
  }
  transmit(';');
}

void transmitLong(unsigned long i) {
  char cc[8];
  int ix=0;
  if (i==0) {
    transmit('0');
  } else {
    while (i>0) {
      cc[ix++] = (i % 10)+0x30;
      i /= 10;
    }
    while (ix > 0) {
/*       while (!(inp(UCSR0A) & (1<<UDRE))) ; */
/*       outp(cc[--ix],UDR0);   */
      while (!(UCSR0A & (1<<UDRE))) ;
      UDR0 = cc[--ix];  
    }
  }
  transmit(';');
}

void transmitString(char* cc) {
  int i;
  for (i=0; i<strlen(cc); i++) {
/*     while (!(inp(UCSR0A) & (1<<UDRE))) ; */
/*     outp(cc[i],UDR0);   */
    while (!(UCSR0A & (1<<UDRE))) ;
    UDR0 = cc[i];  
  }
}


GC_PROC_BEGIN(java_lang_System_exit_int,JInt i) 
  GC_FUNC_ENTER
  exit(i);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_System_exit_int)

GC_VAR_FUNC_BEGIN(JLong,java_lang_System_currentTimeMillis)
     GC_FUNC_ENTER;
{
  JLong time;
  time = getTickTime(0); //*10;
/*   GC_PROC_CALL(done_LCDDisplay_errprint_int,tickCounter); */
  GC_RETURN_VAR(time);
}
GC_FUNC_LEAVE
GC_VAR_FUNC_END(JLong,_java_lang_System_currentTimeMillis)

void _java_lang_System_exit_int(JInt i) {
  exit(i);
}

void java_lang_System_registerNatives() {
  /* Missing implementation */
}

JInt java_lang_System_identityHashCode_Object(void* o) {
  return (JInt) o;
}

void java_lang_System_arraycopy_java_lang_Object_int_java_lang_Object_int_int(void* src, int src_pos, 
							   void* dest, int dest_pos,
							   int length) {
  /* Implementation missing !! */
}

GC_VAR_FUNC_BEGIN(JInt, java_lang_PhonyReader_read, GC_PARAM(java_lang_PhonyReader, this))
  GC_PARAM_REF(java_lang_PhonyReader, this);
  GC_PUSH_PARAM(this);
  GC_FUNC_ENTER
    unsigned char tmp;
    scanf("%c", &tmp);
    GC_RETURN_VAR((int)tmp);
  GC_FUNC_LEAVE
  GC_POP_PARAM(this);
GC_VAR_FUNC_END(Jint, java_lang_PhonyReader_read)

GC_PROC_BEGIN(java_lang_PhonyWriter_print)
  GC_FUNC_ENTER
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print)

GC_PROC_BEGIN(java_lang_PhonyWriter_println) 
  GC_FUNC_ENTER
  transmit('\n');
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println)

GC_PROC_BEGIN(java_lang_PhonyWriter_print_int,int i) 
  GC_FUNC_ENTER
  char c;
transmit(i);
/*   takeBinarySemaphore(0,printMutex); */
/*   if (i==0) { */
/*     transmit('0'); */
/*   } else { */
/*     while (i>0) { */
/*       c = (i % 10) + '0'; */
/*       i /= 10; */
/*       transmit(c); */
/*     } */
/*   } */
/* giveBinarySemaphore(0,printMutex); */
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_int) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_int,int i)
  GC_FUNC_ENTER
  transmitInt(i);
transmit('\n');
/*   char c; */
/*   takeBinarySemaphore(0,printMutex); */
/*   if (i==0) { */
/*     transmit('0'); */
/*   } else { */
/*     while (i>0) { */
/*       c = (i % 10) + '0'; */
/*       i /= 10; */
/*       transmit(c); */
/*     } */
/*   } */
/* transmit('\n'); */
/*     giveBinarySemaphore(0,printMutex); */
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_int) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_long,long i) 
  GC_FUNC_ENTER
  char c;
  takeBinarySemaphore(0,printMutex);
  if (i==0) {
    transmit('0');
  } else {
    while (i>0) {
      c = (i % 10) + '0';
      i /= 10;
      transmit(c);
    }
  }
    giveBinarySemaphore(0,printMutex);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_long) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_long,long i)
  GC_FUNC_ENTER
  transmitLong(i);
  transmit('\n');
/*   char c; */
/*   takeBinarySemaphore(0,printMutex); */
/*   if (i==0) { */
/*     transmit('0'); */
/*   } else { */
/*     while (i>0) { */
/*       c = (i % 10) + '0'; */
/*       i /= 10; */
/*       transmit(c); */
/*     } */
/*   } */
/* transmit('\n'); */
/*     giveBinarySemaphore(0,printMutex); */
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_long) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_java_lang_String,GC_PARAM(java_lang_String,s)) 
  GC_PARAM_REF(java_lang_String,s);
  GC_PUSH_PARAM(s);
  GC_FUNC_ENTER;
  
  GC_REF(JCharArray, data);    
  GC_PUSH_ROOT(data);
  GC_GET_REF(data,s,_java_lang_String_value);
  {
/*     transmit(' '); */
    JInt len,i;
    GC_GET(len,data,_JCharA_length);
    takeBinarySemaphore(0,printMutex);
/*     transmit('\n'); */
    for (i=0; i<len-1; i++) {
      char c;
      c = GC___PTR(data->ref)->data[i].bytes;
      transmit(c);
    }
    giveBinarySemaphore(0,printMutex);
  }

  GC_POP_ROOT(data);
  GC_FUNC_LEAVE
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_PhonyWriter_print_java_lang_String) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_java_lang_String,GC_PARAM(java_lang_String,s)) 
  GC_PARAM_REF(java_lang_String,s);
  GC_PUSH_PARAM(s);
  GC_FUNC_ENTER;
  
  GC_REF(JCharArray, data);    
  GC_PUSH_ROOT(data);
  GC_GET_REF(data,s,_java_lang_String_value);
  {
    JInt len,i;
    GC_GET(len,data,_JCharA_length);
    takeBinarySemaphore(0,printMutex);
    for (i=0; i<len-1; i++) {
      char c;
      c = GC___PTR(data->ref)->data[i].bytes;
      transmit(c);
/*     transmit('\n'); */
    }
    transmit('\n');
    giveBinarySemaphore(0,printMutex);
  }

  GC_POP_ROOT(data);
  GC_FUNC_LEAVE
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_PhonyWriter_println_java_lang_String) 

GC_PROC_BEGIN(java_lang_PhonyWriter_print_char,char i) 
  GC_FUNC_ENTER
    transmit(i);
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_print_char) 

GC_PROC_BEGIN(java_lang_PhonyWriter_println_char,char i)
  GC_FUNC_ENTER
  transmit(i);
  transmit('\n');
  GC_FUNC_LEAVE
GC_PROC_END(java_lang_PhonyWriter_println_char) 

GC_PROC_BEGIN(java_lang_ErrWriter_print_java_lang_String,GC_PARAM(java_io_PrintStream,p),GC_PARAM(java_lang_String,s))
  GC_PARAM_REF(java_lang_String,s);
  GC_PUSH_PARAM(s);
  GC_PARAM_REF(java_io_PrintStream,p);
  GC_PUSH_PARAM(p);
  GC_FUNC_ENTER;
{
  GC_REF(JCharArray, data);
  GC_PUSH_ROOT(data);
  if (GC_IS_NULL(s)) {
    printf("null");
  } else {
    GC_GET_REF(data,s,_java_lang_String_value);
    {
      JInt len,i;
      GC_GET(len,data,_JCharA_length);
      for (i=0; i<len; i++) {
        char c;
        c = GC___PTR(data->ref)->data[i].bytes;
        putchar(c);
      }
    }
  }
  GC_POP_ROOT(data);
}
  GC_FUNC_LEAVE
  GC_POP_PARAM(p);
  GC_POP_PARAM(s);
GC_PROC_END(java_lang_ErrWriter_print_java_lang_String)


