#include <class_indices.h>

#ifdef SE_LTH_CS_REALTIME_SEMAPHORE_COUNTINGSEM_INDEX

#include <javatypes.h>
#include <gc.h>
/* #include <pthread.h> */
/* #include <semaphore.h> */
#include <se_lth_cs_realtime_semaphore_CountingSem.h>

#include <AVR_Semaphore.h>

GC_VAR_FUNC_BEGIN(long,se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),int iValue)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
/*   sem_t* sem; */
/*   sem=malloc(sizeof(sem_t)); */
/*   sem_init(sem,0,0); */

  Semaphore* sem;
  sem = allocSemaphore(0,iValue);

  GC_RETURN_VAR((long)sem);
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_VAR_FUNC_END(long,se_lth_cs_realtime_semaphore_CountingSem_createCountingSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),long target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
  giveCountingSemaphore(0,(Semaphore*) target);
/*   sem_post((sem_t*)target); */
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_CountingSem_giveCountingSem_int)

GC_PROC_BEGIN(se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_long,GC_PARAM(se_lth_cs_realtime_semaphore_CountingSem,this),long target)
     GC_PARAM_REF(se_lth_cs_realtime_semaphore_CountingSem,this);
     GC_PUSH_PARAM(this);
     GC_FUNC_ENTER;
{
  takeCountingSemaphore(0,(Semaphore*) target);
/*   sem_wait((sem_t*)target); */
}
GC_FUNC_LEAVE
GC_POP_PARAM(this);
GC_PROC_END(se_lth_cs_realtime_semaphore_CountingSem_takeCountingSem_int)


#endif
